// Copyright (C) 2005-2007 Lionel Duchateau, kurtnoise@free.fr
//
// This library is free software: you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this library. If not, see <http://www.gnu.org/licenses/>.
//
// To compile Yamb 2.xxx, you need :
//    - JVCL components : http://homepages.borland.com/jedi/jvcl/
//    - TMMS Unicode components : http://www.tmssoftware.com/
//    - DSPack components : http://www.progdigy.com/
//    - ABf components : http://www.abf-dev.com/abf-components.shtml
//    - DOSCommand component : include in the sources
//    - OpenDirDialog component : include in the sources
//    

unit UProperties;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, TntComCtrls, StdCtrls, Buttons, TntButtons, ExtCtrls,
  TntExtCtrls, TntStdCtrls, JvExForms, JvBaseThumbnail, JvThumbViews,
  TntDialogs, TntExtDlgs, TntSysUtils;

type
  TPropForm = class(TForm)
    PageControl: TTntPageControl;
    Tab1: TTntTabSheet;
    Tab2: TTntTabSheet;
    btOk: TTntBitBtn;
    btCancel: TTntBitBtn;
    gbSource: TTntGroupBox;
    gbProperties: TTntGroupBox;
    TntImage1: TTntImage;
    chTagSupport: TTntCheckBox;
    lbFile1: TTntLabel;
    lbType1: TTntLabel;
    lbInfo1: TTntLabel;
    lbLang: TTntLabel;
    cbLang: TTntComboBox;
    lbBrand: TTntLabel;
    cbBrand: TTntComboBox;
    lbTrack: TTntLabel;
    cbTrack: TTntComboBox;
    lbPAR: TTntLabel;
    cbPAR: TTntComboBox;
    lbSBR: TTntLabel;
    cbSBR: TTntComboBox;
    lbCopyright: TTntLabel;
    edCopyright: TTntEdit;
    lbFrameRate: TTntLabel;
    edFrameRate: TTntEdit;
    lbDelay: TTntLabel;
    edDelay: TTntEdit;
    lbInterleave: TTntLabel;
    edInterleave: TTntEdit;
    chKeepNVop: TTntCheckBox;
    gbTags: TTntGroupBox;
    lbName: TTntLabel;
    edName: TTntEdit;
    lbArtist: TTntLabel;
    edArtist: TTntEdit;
    lbYear: TTntLabel;
    edYear: TTntEdit;
    lbWriter: TTntLabel;
    edWriter: TTntEdit;
    lbTrackNum: TTntLabel;
    edTrackN1: TTntEdit;
    edTrackNum2: TTntEdit;
    TntLabel1: TTntLabel;
    lbAlbum: TTntLabel;
    edAlbum: TTntEdit;
    lbDiskNum: TTntLabel;
    edDiskNum1: TTntEdit;
    TntLabel2: TTntLabel;
    edDiskNum2: TTntEdit;
    edGroup: TTntEdit;
    lbGroup: TTntLabel;
    lbTempo: TTntLabel;
    edTempo: TTntEdit;
    lbComposer: TTntLabel;
    edComposer: TTntEdit;
    lbGenre: TTntLabel;
    cbGenre: TTntComboBox;
    chCompile: TTntCheckBox;
    TabPic: TTntTabSheet;
    gbPicture: TTntGroupBox;
    ThumbView: TJvThumbView;
    btAdd: TTntButton;
    btDelete: TTntButton;
    OpenPictureDialog: TTntOpenPictureDialog;
    FontDialog: TFontDialog;
    btFont: TTntBitBtn;
    edFontName: TTntEdit;
    edFontSize: TTntEdit;
    lbFontName: TTntLabel;
    lbFontSize: TTntLabel;
    chGapless: TTntCheckBox;
    dpbt2: TTntSpeedButton;
    spbt1: TTntSpeedButton;
    TabMore: TTntTabSheet;
    gbComments: TTntGroupBox;
    MemoComments: TTntMemo;
    gbMore: TTntGroupBox;
    lbEncoder: TTntLabel;
    edEncoder: TTntEdit;
    lbTool: TTntLabel;
    edTool: TTntEdit;
    procedure btOkClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure edDelayKeyPress(Sender: TObject; var Key: Char);
    procedure edFrameRateKeyPress(Sender: TObject; var Key: Char);
    procedure edInterleaveKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure edTrackN1KeyPress(Sender: TObject; var Key: Char);
    procedure edTrackNum2KeyPress(Sender: TObject; var Key: Char);
    procedure chTagSupportClick(Sender: TObject);
    procedure btAddClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ThumbViewMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure btFontClick(Sender: TObject);
    procedure AddTrackNameItem(aCb: TTnTComboBox);
    procedure cbPARChange(Sender: TObject);
    procedure dpbt2Click(Sender: TObject);
    procedure spbt1Click(Sender: TObject);
    procedure cbLangChange(Sender: TObject);
    procedure cbBrandChange(Sender: TObject);
    procedure cbTrackChange(Sender: TObject);
    procedure cbSBRChange(Sender: TObject);
    procedure edCopyrightChange(Sender: TObject);
    procedure edFrameRateChange(Sender: TObject);
    procedure edDelayChange(Sender: TObject);
    procedure edFontSizeChange(Sender: TObject);
    procedure chKeepNVopClick(Sender: TObject);
    procedure edInterleaveChange(Sender: TObject);
    procedure edFontNameChange(Sender: TObject);
   
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PropForm: TPropForm;
  ii : Integer;

implementation

uses UMain, URessources, UCustomVal;

{$R *.dfm}

procedure TPropForm.btOkClick(Sender: TObject);
begin
     if Tagger then MainForm.WriteTags2 else MainForm.WriteInfo;
     Close;
end;

procedure TPropForm.btCancelClick(Sender: TObject);
begin
     Close;
end;

procedure TPropForm.edDelayKeyPress(Sender: TObject; var Key: Char);
begin
     if not (Key in ['0'..'9', '-', DecimalSeparator, Chr(VK_BACK), Chr(VK_DELETE)]) then
       Key := #0;
     if Key = DecimalSeparator then
     if Pos(DecimalSeparator, edDelay.Text) <> 0 then
      Key := #0;
end;

procedure TPropForm.edFrameRateKeyPress(Sender: TObject; var Key: Char);
begin
     if not (Key in ['0'..'9', DecimalSeparator, Chr(VK_BACK), Chr(VK_DELETE)]) then
       Key := #0;
     if Key = DecimalSeparator then
     if Pos(DecimalSeparator, edFrameRate.Text) <> 0 then
      Key := #0;
end;

procedure TPropForm.edInterleaveKeyPress(Sender: TObject; var Key: Char);
begin
     if not (Key in ['0'..'9', DecimalSeparator, Chr(VK_BACK), Chr(VK_DELETE)]) then
       Key := #0;
     if Key = DecimalSeparator then
     if Pos(DecimalSeparator, edFrameRate.Text) <> 0 then
      Key := #0;
end;

procedure TPropForm.FormCreate(Sender: TObject);
begin
     // Check the right Font
   // if IsWindowsVista then SetVistaFonts(Self);
end;

procedure TPropForm.edTrackN1KeyPress(Sender: TObject; var Key: Char);
begin
     if not (Key in ['0'..'9', DecimalSeparator, Chr(VK_BACK), Chr(VK_DELETE)]) then
       Key := #0;
     if Key = DecimalSeparator then
     if Pos(DecimalSeparator, edFrameRate.Text) <> 0 then
      Key := #0;
end;

procedure TPropForm.edTrackNum2KeyPress(Sender: TObject; var Key: Char);
begin
     if not (Key in ['0'..'9', DecimalSeparator, Chr(VK_BACK), Chr(VK_DELETE)]) then
       Key := #0;
     if Key = DecimalSeparator then
     if Pos(DecimalSeparator, edFrameRate.Text) <> 0 then
      Key := #0;
end;



procedure TPropForm.chTagSupportClick(Sender: TObject);
begin
     Tab2.TabVisible := chTagSupport.Checked;
     TabPic.TabVisible := chTagSupport.Checked;
     TabMore.TabVisible := chTagSupport.Checked;
     if chTagSupport.Checked then PageControl.ActivePage := Tab2
     else PageControl.ActivePage := Tab1;            
end;

procedure TPropForm.btAddClick(Sender: TObject);
begin
     if OpenPictureDialog.Execute then
       begin
            ThumbView.AddFromFile(OpenPictureDialog.FileName);
            ThumbView.SelectedFile := OpenPictureDialog.FileName;
       end;
     if ThumbView.Count > 0 then btDelete.Enabled := True;
end;

procedure TPropForm.btDeleteClick(Sender: TObject);
begin
     if MessageDlg('Do you really want to delete this picture ?', mtInformation,[mbYes, mbNo],0) = mrYes then
       begin
            if ThumbView.Selected <> -1 then ThumbView.Delete(ThumbView.Selected);
            if ThumbView.Count = 0 then btDelete.Enabled := False;
       end;
end;

procedure TPropForm.FormShow(Sender: TObject);
begin
     if IsWindowsVista then
       begin
            cbLang.Style := csDropDown;
            cbPar.Style := csDropDown;
       end
     else
       begin
            if PropForm.cbPAR.Style <> csDropDownList then PropForm.cbPAR.Style := csDropDownList;
       end;
     if (Tab1.TabVisible) then PageControl.ActivePage := Tab1 else PageControl.ActivePage := Tab2;
     if MainForm.edTagger.Text <> '' then
       begin
            if {(Tnt_WideLowerCase(WideExtractFileName(MainForm.edTagger.Text)) = 'atomicparsley.exe') or }
               (Tnt_WideLowerCase(WideExtractFileName(MainForm.edTagger.Text)) = 'mp4box.exe') then
                  chTagSupport.Enabled := True else chTagSupport.Enabled := False;
       end
     else chTagSupport.Enabled := False;

      ii := MainForm.MP4ListView.ItemIndex+1;
end;


procedure TPropForm.ThumbViewMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
     if ThumbView.Count > 0 then ThumbView.Hint := WideExtractFileName(ThumbView.SelectedFile);
end;

procedure TPropForm.btFontClick(Sender: TObject);
begin
     if FontDialog.Execute then
       begin
            edFontName.Text := FontDialog.Font.Name;
            edFontSize.Text := IntToStr(FontDialog.Font.Size);
       end;
end;

procedure TPropForm.AddTrackNameItem(aCb: TTnTComboBox);
var I: Integer;
begin
     for I := 0 to MAX_PRESETS - 1 do
        begin
             if (aCb.Items[I] = aCb.Text) then Break;
             if (aCb.Items[I] = ' ') then
               begin
                    aCb.Items[I] := aCb.Text;
                    TrackNamePresets[I + 1] := aCb.Text;
                    Break;
               end;
        end;
end;


procedure TPropForm.cbPARChange(Sender: TObject);
begin
     case cbPAR.ItemIndex of
         5 : begin
                  CustomValForSplit := False;
                  CustomVal.edCustomVal.Visible := False;
                  CustomVal.edPAR1.Visible := True;
                  CustomVal.edPAR2.Visible := True;
                  CustomVal.Label1.Visible := True;
                  CustomVal.ShowModal;
             end;
     end;
     MainForm.WriteInfo;
end;

procedure TPropForm.dpbt2Click(Sender: TObject);
begin
     if ii <> MainForm.MP4ListView.Items.Count then
      begin
           if MainForm.MP4ListView.Items[ii].Checked = False then inc(ii);
           MainForm.MP4ListView.Items[ii].Selected := true;
           MainForm.ReadInfo;
           inc(ii);
      end;
end;

procedure TPropForm.spbt1Click(Sender: TObject);
begin
     if MainForm.MP4ListView.Items[0].Selected = False then
       begin
            dec(ii);
            if MainForm.MP4ListView.Items[ii-1].Checked = False then dec(ii);
            MainForm.MP4ListView.Items[ii-1].Selected := true;
            MainForm.ReadInfo;
       end;
end;

procedure TPropForm.cbLangChange(Sender: TObject);
begin
     MainForm.WriteInfo;
end;

procedure TPropForm.cbBrandChange(Sender: TObject);
begin
     MainForm.WriteInfo;
end;

procedure TPropForm.cbTrackChange(Sender: TObject);
begin
     MainForm.WriteInfo;
end;

procedure TPropForm.cbSBRChange(Sender: TObject);
begin
     MainForm.WriteInfo;
end;

procedure TPropForm.edCopyrightChange(Sender: TObject);
begin
     MainForm.WriteInfo;
end;

procedure TPropForm.edFrameRateChange(Sender: TObject);
begin
     MainForm.WriteInfo;
end;

procedure TPropForm.edDelayChange(Sender: TObject);
begin
     MainForm.WriteInfo;
end;

procedure TPropForm.edFontSizeChange(Sender: TObject);
begin
     MainForm.WriteInfo;
end;

procedure TPropForm.chKeepNVopClick(Sender: TObject);
begin
     MainForm.WriteInfo;
end;

procedure TPropForm.edInterleaveChange(Sender: TObject);
begin
     MainForm.WriteInfo;
end;

procedure TPropForm.edFontNameChange(Sender: TObject);
begin
     MainForm.WriteInfo;
end;

end.
