// Copyright (C) 2005-2007 Lionel Duchateau, kurtnoise@free.fr
//
// This library is free software: you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this library. If not, see <http://www.gnu.org/licenses/>.
//
// To compile Yamb 2.xxx, you need :
//    - JVCL components : http://homepages.borland.com/jedi/jvcl/
//    - TMMS Unicode components : http://www.tmssoftware.com/
//    - DSPack components : http://www.progdigy.com/
//    - ABf components : http://www.abf-dev.com/abf-components.shtml
//    - DOSCommand component : include in the sources
//    - OpenDirDialog component : include in the sources
//

unit URessources;

interface

uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Registry,
     ComCtrls, TntSysUtils, TntComCtrls, Forms, Dialogs, iniFiles, UMain, MediaInfodll,
     ShlObj, TaskDialog, TntTaskDialog, UProperties, TntStdCtrls;

type
    TOSVERSIONINFOEX = record
    dwOSVersionInfoSize: DWORD;
    dwMajorVersion: DWORD;
    dwMinorVersion: DWORD;
    dwBuildNumber: DWORD;
    dwPlatformId: DWORD;
    szCSDVersion: array[0..127] of AnsiChar; { Maintenance string for PSS usage }
    wServicePackMajor: WORD;
    wServicePackMinor: WORD;
    wSuiteMask: WORD;
    wProductType: BYTE;
    wReserved: BYTE;
end;

type
  POpenFilenameA = ^TOpenFilenameA;
  POpenFilename = POpenFilenameA;
  tagOFNA = packed record
    lStructSize: DWORD;
    hWndOwner: HWND;
    hInstance: HINST;
    lpstrFilter: PAnsiChar;
    lpstrCustomFilter: PAnsiChar;
    nMaxCustFilter: DWORD;
    nFilterIndex: DWORD;
    lpstrFile: PAnsiChar;
    nMaxFile: DWORD;
    lpstrFileTitle: PAnsiChar;
    nMaxFileTitle: DWORD;
    lpstrInitialDir: PAnsiChar;
    lpstrTitle: PAnsiChar;
    Flags: DWORD;
    nFileOffset: Word;
    nFileExtension: Word;
    lpstrDefExt: PAnsiChar;
    lCustData: LPARAM;
    lpfnHook: function(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT stdcall;
    lpTemplateName: PAnsiChar;
  end;
  TOpenFilenameA = tagOFNA;
  TOpenFilename = TOpenFilenameA;

function GetOpenFileName(var OpenFile: TOpenFilename): Bool; stdcall; external 'comdlg32.dll'  name 'GetOpenFileNameA';
function GetSaveFileName(var OpenFile: TOpenFilename): Bool; stdcall; external 'comdlg32.dll'  name 'GetSaveFileNameA';


function SystemVersionText: string;
function right(substr: string; s: string): string;
function lefty(substr: string; s: string): string;
procedure AddString(var Dest: string; const Source: string; const LineFeed: boolean = True);
procedure AddMsg(msg: WideString; flag: integer);
procedure LogFileExists(FileName : WideString);
function HexToInt(const Value: String): Integer;
function Short2FullLanguageName(StShort: Widestring): Widestring;
function Lang2Nbr(Lang: WideString): Integer;
function Full2ShortLanguageName(StLong: WideString): WideString;
function CheckMP4FileExt(FileName: WideString): Boolean;
function Check3GPPFileExt(FileName: WideString): Boolean;
function CheckCatFileExt(FileName: WideString): Boolean;
procedure ExchangeItems(lv: TTntListView; const ItemFrom, ItemTo: Cardinal);
procedure SetVistaFonts(const AForm: TCustomForm);
procedure ExtendGlass(const AHandle: THandle; const AMargins: TRect);
function CompositingEnabled: Boolean;
function IsWindowsVista: Boolean;
function OpenSaveFileDialog(ParentHandle: THandle; const DefExt, Filter, InitialDir, Title: string; var FileName: string;
  MustExist, OverwritePrompt, NoChangeDir, DoOpen, MultiSelect : Boolean): Boolean;
function TaskDialog(const AHandle: THandle; const ATitle, ADescription,
  AContent: string; const Icon, Buttons: Integer): Integer;
function FormatFileSize(const FileSize: Int64): String;
function rSI(ident: WideString; default: WideString = ''): WideString;
function rSI2(ident: WideString; default: WideString = ''): WideString;
function rSI3(ident: WideString; default: WideString = ''): WideString;
function rSI4(ident: WideString; default: WideString = ''): WideString;
function rSI5(ident: WideString; default: WideString = ''): WideString;
function rSI6(ident: WideString; default: WideString = ''): WideString;
function rSI7(ident: WideString; default: WideString = ''): WideString;
function rSI8(ident: WideString; default: WideString = ''): WideString;
function rSI9(ident: WideString; default: WideString = ''): WideString;
function rSI10(ident: WideString; default: WideString = ''): WideString;
procedure LoadIniStrings(iniLangFile: WideString);
function DecodeUTF8(const Source: string): WideString;
function EncodeUTF8(const Source: WideString): string;
function GetCovr(FileName : WideString) : Boolean;
function GetTitle(FileName : WideString) : WideString;
function GetAlbum(FileName : WideString) : WideString;
function GetYear(FileName : WideString) : WideString;
function GetDuration(FileName: WideString) : WideString;
function GetArtist(FileName: WideString) : WideString;
procedure AddFileForShellTV(FileName: WideString);
function CheckListBoxItems(ListView: TTntListView): boolean;
function GetWindowsLanguage(LCTYPE: LCTYPE {type of information}): string;
procedure SaveListviewStrings(listview: TTnTListView; const filename: WideString);
function CharReplace(const Source: string; oldChar, newChar: Char): string;
procedure OverWriteMsg(TaskDiag : TTntTaskDialog; OutputFile : WideString);
procedure MP4BoxMissingMsg(TaskDiag : TTntTaskDialog);
procedure DeleteItemMsg(TaskDiag: TTntTaskDialog);
procedure MsgNotCompatible(TaskDiag: TTntTaskDialog; Num : Integer);
procedure MsgProcessRunning(TaskDiag: TTntTaskDialog);
procedure MsgrawAVC(TaskDiag: TTntTaskDialog);
procedure GetAllFiles(mask: string);
procedure EraseTagsEdit;
function GetGenre(FileName : WideString): WideString;
function SetNameTags(prefix: Integer): WideString;
function SetArtistTags(prefix: Integer): WideString;
function SetAlbumTags(prefix: Integer): WideString;
function SetYearTags(prefix: Integer): WideString;
function SetPictureTags(prefix: Integer): WideString;
function SetGenreTags(prefix: Integer): WideString;
function SetGroupTags(prefix: Integer): WideString;
function SetWriterTags(prefix: Integer): WideString;
function SetDiskPTags(prefix: Integer): WideString;
function SetDiskTTags(prefix: Integer): WideString;
function SetTrackPTags(prefix: Integer): WideString;
function SetTrackTTags(prefix: Integer): WideString;
function SetTempoTags(prefix: Integer): WideString;
function SetComposerTags(prefix: Integer): WideString;
function SetEncoderTags(prefix: Integer): WideString;
function SetToolTags(prefix: Integer): WideString;
function SetCommentsTags(prefix: Integer): WideString;
function SetCompileTags(prefix: Integer): WideString;
function SetGaplessTags(prefix: Integer): WideString;
function CheckListViewBrandNameItems(ListView: TTntListView; Column : Integer): boolean;

const MAX_PRESETS = 10;

var aIniFile : TIniFile;
    CreationList_Part1, CreationList_Part2, EditionList_Part1, EditionList_Part2,
    EditionList_Part3, EditionList_Part4, SettingsList_Part1,
    MP4FileCreation, GPPFileCreation, Yclosed, Floaded, Msg1, Msg2, Msg3,
    Msg4, Msg41, Msg5, Msg6, Msg7, Msg8, Msg9, Msg10, Msg11, Msg12, Msg13,
    MsgOverwritten, MsgOverwriteOrNot, ConvAborted, ConvFailed, ConvSucceed,
    ExtractAborted, ExtractFailed, ExtractSucceed, ConcatAborted,
    ConcatFailed, ConcatSucceed, CreateAborted, CreateFailed, CreateSucceed,
    SplitAborted, SplitFailed, SplitSucceed, TagAborted, TagFailed,
    TagSucceed, ImportAVIVideo, ImportAVIAudio, FileW, FileI, FileTag,
    FileA, FileS, AVCinAVIDetect, CmdUsedForExtract, MsgNotCompatible1,
    MsgNotCompatible2, MsgStarted, MsgOSType, MsgMP4BoxFound, MsgMP4BoxMissing,
    MsgTaggerMissing, BadTagger, BadMP4Box, MuxTitleText,
    Split10, Split11, Split12, Split13, Split14, Split15,
    Split20, Split21, Split22, Split23, Split24, Split30, Split31,
    Split32, Split33, Split34, Split40, Split41, Split50, Split51,
    Msgx264VFWCompatiblity, MsgNotifying, btYes, btNo, ProcessIsRunningMsg,
    ExtractVideoStream, ExtractAudioStream, ExtractToRawAll,
    ExtractToAVI, ExtractToRAW, ExtractToMP4, ExtractToSRT, ExtractToTTXT,
    ExtractToOGM, ExtractToCUE, ImportVobsubFile, ImportISOFile,
    ImportSRTFile, ImportTTXTFile, ImportAACFile, ImportImageFile,
    StoringFile, ImportM4VFile, ImportPSVideoFile, ImportPSAudioFile,
    ImportTSFile, ImportMP3File, ImportAVCFile, ImportNHNTFile,
    ImportNHMLFile, ImportANRFile, ImportEVRCFile, ImportSMVFile,
    ImportAMRWBFile, ImportQCPFile, ImportH263File, ImportOGGVideo,
    ImportOGGAudio, ImportSAFFile, ImportTeXMLFile, UnknownPID,
    InvalidUTF, MsgError, ImportAMRFile, ClickToHide, ClickToSeeMore,
    MsgNewTask, FinishCaption, lbType, lbVideoStream, lbAudioStream,
    lbSubStream, lbInfo, lbFile, MsgTaggerFound, MsgTaggerFoundButNotSupported,
    rawAVCMsg, clickToHideMsg, clickToSeeMoreMsg, OverwriteMsgExp,
    MsgExtractRawVideo, MsgExtractRawAudio, MsgEncapsulateVideoInMP4,
    MsgEncapsulateVideoInAVI, MsgExtractSubtitle, MsgExtractVobSub,
    MsgExtractChapters, MsgToSRTFormat, MsgToTTXTFormat, MsgFileSavedIn,
    MsgToOGMTextFormat, MsgToCueSheetFormat, MsgCmdUsedForExtraction : WideString;

    TrackNamePresets : array[1..MAX_PRESETS] of string;

ResourceString

  eInvalidViewstyle = '%s: the listview %s is not in vsReport mode.';

implementation

const
     VER_SERVER_NT                      = $80000000;
     VER_WORKSTATION_NT                 = $40000000;
     VER_SUITE_SMALLBUSINESS            = $00000001;
     VER_SUITE_ENTERPRISE               = $00000002;
     VER_SUITE_BACKOFFICE               = $00000004;
     VER_SUITE_COMMUNICATIONS           = $00000008;
     VER_SUITE_TERMINAL                 = $00000010;
     VER_SUITE_SMALLBUSINESS_RESTRICTED = $00000020;
     VER_SUITE_EMBEDDEDNT               = $00000040;
     VER_SUITE_DATACENTER               = $00000080;
     VER_SUITE_SINGLEUSERTS             = $00000100;
     VER_SUITE_PERSONAL                 = $00000200;
     VER_SUITE_BLADE                    = $00000400;

     VER_NT_WORKSTATION       = $0000001;
     VER_NT_DOMAIN_CONTROLLER = $0000002;
     VER_NT_SERVER            = $0000003;

     //Default Name Fonts
     VistaFont = 'Segoe UI';
     XPFont = 'Tahoma';

     TD_ICON_BLANK = 100;
     TD_ICON_WARNING = 101;
     TD_ICON_QUESTION = 102;
     TD_ICON_ERROR = 103;
     TD_ICON_INFORMATION = 104;
     TD_ICON_BLANK_AGAIN = 105;
     TD_ICON_SHIELD = 106;

  //Modification Olivier Lance
  {TD_ICON_BLANK = 0;
  TD_ICON_WARNING = 84;
  TD_ICON_QUESTION = 99;
  TD_ICON_ERROR = 98;
  TD_ICON_INFORMATION = 81;
  TD_ICON_SHIELD_QUESTION = 104;
  TD_ICON_SHIELD_ERROR = 105;
  TD_ICON_SHIELD_OK = 106;        
  TD_ICON_SHIELD_WARNING = 107;}

     TD_BUTTON_OK = 1;
     TD_BUTTON_YES = 2;
     TD_BUTTON_NO = 4;
     TD_BUTTON_CANCEL = 8;
     TD_BUTTON_RETRY = 16;
     TD_BUTTON_CLOSE = 32;

     TD_RESULT_OK = 1;
     TD_RESULT_CANCEL = 2;
     TD_RESULT_RETRY = 4;
     TD_RESULT_YES = 6;
     TD_RESULT_NO = 7;
     TD_RESULT_CLOSE = 8;

      OFN_DONTADDTORECENT = $02000000;
      OFN_FILEMUSTEXIST = $00001000;
      OFN_HIDEREADONLY = $00000004;
      OFN_PATHMUSTEXIST = $00000800;
      OFN_OVERWRITEPROMPT = $00000002;
       OFN_NOCHANGEDIR = $00000008;
      OFN_ALLOWMULTISELECT = $00000200;


procedure AddString(var Dest: string; const Source: string; const LineFeed: boolean = True);
begin
     if Dest = '' then Dest:= Source
     else if LineFeed then Dest:= Dest + ' ' + Source
     else Dest:= Dest + Source;
end;

function SystemVersionText: string;
var
   osvi: TOSVERSIONINFOEX;
   bOsVersionInfoEx: boolean;

   ProductType : String;
begin
     result:= '';

  FillChar(osvi, SizeOf(TOSVERSIONINFOEX), 0);
  osvi.dwOSVersionInfoSize:= SizeOf(TOSVERSIONINFOEX);

  // We try to call first GetVersionEx with the extended structure.
  // Otherwhise error, we try with the normal structure.
  bOsVersionInfoEx:= GetVersionEx(POSVERSIONINFO(@osvi)^);
  if not bOsVersionInfoEx then
  begin
    // The extended structure doesn't work
    osvi.dwOSVersionInfoSize:= SizeOf(TOSVERSIONINFO); 
    if not GetVersionEx(POSVERSIONINFO(@osvi)^) then 
      exit; 
  end; 

  case osvi.dwPlatformId of 
    // Tests for Winodws NT familly
    VER_PLATFORM_WIN32_NT: 
    begin 
      // Product Test
      if osvi.dwMajorVersion <= 4 then
        AddString(result, 'Windows NT');
      if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 0) then 
        AddString(result, 'Windows 2000');

      if bOsVersionInfoEx then  // Avec les informations ?tendues 
      begin 
        // Station Type Test
        if osvi.wProductType = VER_NT_WORKSTATION then 
        begin 
          if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 1) then 
          AddString(result, 'Windows XP');
          if (osvi.dwMajorVersion >=6) then AddString(result, 'Windows Vista');
          if (osvi.dwMajorVersion <6) then
             begin
          if (osvi.wSuiteMask and VER_SUITE_PERSONAL) <> 0 then 
            AddString(result, ' Home Edition', False) 
          else 
            AddString(result, ' Professional', False);
              end;
        end 

        // Server Type Test
        else if osvi.wProductType = VER_NT_SERVER then
        begin 
          if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 1) then 
            AddString(result, 'Windows .NET');
          if (osvi.dwMajorVersion < 6) then
             begin
          if (osvi.wSuiteMask and VER_SUITE_DATACENTER) <> 0 then 
            AddString(result, ' DataCenter Server', False) 
          else if (osvi.wSuiteMask and VER_SUITE_ENTERPRISE) <> 0 then 
            if osvi.dwMajorVersion = 4 then 
              AddString(result, ' Advanced Server', False) 
            else 
              AddString(result, ' Enterprise Server', False)
          else if osvi.wSuiteMask = VER_SUITE_BLADE then
            AddString(result, ' Web Server', False)
          else
            AddString(result, ' Server', False);
            end;
        end 
      end 
      else // we must use the registry for the NT previous versions
      begin 
        With TRegistry.Create Do
        Try 
          RootKey := HKEY_LOCAL_MACHINE; 
          OpenKey('SYSTEM\\CurrentControlSet\\Control\\ProductOptions',False); 
          ProductType := ReadString('ProductType'); 
        Finally 
          Free; 
        End; 
        if ProductType = 'WINNT' then 
          AddString(result, ' Professional', False); 
        if ProductType = 'LANMANNT' then 
          AddString(result, ' Server', False);
        if ProductType = 'SERVERNT' then 
          AddString(result, ' Advanced Server', False);
      end; 

     // Version, "Service Pack" or construction number if existing
     if osvi.dwMajorVersion <= 6  then 
        AddString(result, Format('(version %d.%d, Build %d : %s)',
          [osvi.dwMajorVersion, 
           osvi.dwMinorVersion,
           osvi.dwBuildNumber and $FFFF,
           osvi.szCSDVersion]))
      else
        AddString(result, Format('%s (Build %d)', 
          [osvi.szCSDVersion,
           osvi.dwBuildNumber and $FFFF]));
    end; 

     // Tests for Windows 9x Familly 
    VER_PLATFORM_WIN32_WINDOWS: 
    begin 
      if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 0) then 
      begin 
        AddString(result, 'Windows 95');
        if (osvi.szCSDVersion[1] = 'C') or (osvi.szCSDVersion[1] = 'B') then 
          AddString(result, ' OSR2', False); 
      end; 

      if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 10) then 
      begin
        AddString(result, 'Windows 98');
        if osvi.szCSDVersion[1] = 'A' then 
          AddString(result, ' SE', False);
      end;

      if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 90) then
        AddString(result, 'Windows Millennium Edition');
    end;
  end;
end;


function right(substr: string; s: string): string;
begin
  if pos(substr,s)=0 then result:='' else
    result:=copy(s, pos(substr, s)+length(substr), length(s)-pos(substr, s)+length(substr));
end;

function lefty(substr: string; s: string): string;
begin
  result:=copy(s, 1, pos(substr, s)-1);
end;

procedure AddMsg(msg: WideString; flag: integer);
var Log : TListItem;
begin
     Log := MainForm.ETAListView.Items.Add;
     if flag = 0 then Log.ImageIndex := 0
     else if flag = 1 then Log.ImageIndex := 1
     else if flag = 2 then Log.ImageIndex := 2
     else Log.ImageIndex := 3;
     Log.SubItems.Add(FormatDateTime('hh:nn:ss',Now));
     Log.SubItems.Add(msg);
end;

procedure LogFileExists(FileName : WideString);
begin
     if WideFileExists(WideExtractFilePath(FileName)+'Yamb.log') then
        WideDeleteFile(WideExtractFilePath(FileName)+'Yamb.log');
end;

function HexToInt(const Value: String): Integer;
begin
     Result := StrToInt('$' + Value);
end;

function DecodeUTF8(const Source: string): WideString;
var
  Index, SourceLength, FChar, NChar: Cardinal;
begin
  { Convert UTF-8 to unicode }
  Result := '';
  Index := 0;
  SourceLength := Length(Source);
  while Index < SourceLength do
  begin
    Inc(Index);
    FChar := Ord(Source[Index]);
    if FChar >= $80 then
    begin
      Inc(Index);
      if Index > SourceLength then exit;
      FChar := FChar and $3F;
      if (FChar and $20) <> 0 then
      begin
        FChar := FChar and $1F;
        NChar := Ord(Source[Index]);
        if (NChar and $C0) <> $80 then  exit;
        FChar := (FChar shl 6) or (NChar and $3F);
        Inc(Index);
        if Index > SourceLength then exit;
      end;
      NChar := Ord(Source[Index]);
      if (NChar and $C0) <> $80 then exit;
      Result := Result + WideChar((FChar shl 6) or (NChar and $3F));
    end
    else
      Result := Result + WideChar(FChar);
  end;
end;

function EncodeUTF8(const Source: WideString): string;
var
  Index, SourceLength, CChar: Cardinal;
begin
  { Convert unicode to UTF-8 }
  Result := '';
  Index := 0;
  SourceLength := Length(Source);
  while Index < SourceLength do
  begin
    Inc(Index);
    CChar := Cardinal(Source[Index]);
    if CChar <= $7F then
      Result := Result + Source[Index]
    else if CChar > $7FF then
    begin
      Result := Result + Char($E0 or (CChar shr 12));
      Result := Result + Char($80 or ((CChar shr 6) and $3F));
      Result := Result + Char($80 or (CChar and $3F));
    end
    else
    begin
      Result := Result + Char($C0 or (CChar shr 6));
      Result := Result + Char($80 or (CChar and $3F));
    end;
  end;
end;


function Short2FullLanguageName(StShort: Widestring): Widestring;
begin
  if StShort = #0#0 then begin Result := ''; Exit; end; //none
  //ISO 639 language codes, brought from vStrip
  if StShort = 'aa' then begin Result := 'Afar'; Exit; end;
  if StShort = 'ab' then begin Result := 'Abkhazian'; Exit; end;
  if StShort = 'af' then begin Result := 'Afrikaans'; Exit; end;
  if StShort = 'am' then begin Result := 'Amharic'; Exit; end;
  if StShort = 'ar' then begin Result := 'Arabic'; Exit; end;
  if StShort = 'as' then begin Result := 'Assamese'; Exit; end;
  if StShort = 'ay' then begin Result := 'Aymara'; Exit; end;
  if StShort = 'az' then begin Result := 'Azerbaijani'; Exit; end;
  if StShort = 'ba' then begin Result := 'Bashkir'; Exit; end;
  if StShort = 'be' then begin Result := 'Byelorussian'; Exit; end;
  if StShort = 'bg' then begin Result := 'Bulgarian'; Exit; end;
  if StShort = 'bh' then begin Result := 'Bihari'; Exit; end;
  if StShort = 'bi' then begin Result := 'Bislama'; Exit; end;
  if StShort = 'bn' then begin Result := 'Bengali'; Exit; end;
  if StShort = 'bo' then begin Result := 'Tibetan'; Exit; end;
  if StShort = 'br' then begin Result := 'Breton'; Exit; end;
  if StShort = 'ca' then begin Result := 'Catalan'; Exit; end;
  if StShort = 'co' then begin Result := 'Corsican'; Exit; end;
  if StShort = 'cs' then begin Result := 'Czech'; Exit; end;
  if StShort = 'cy' then begin Result := 'Welsh'; Exit; end;
  if StShort = 'da' then begin Result := 'Danish'; Exit; end; //Danish
  if StShort = 'de' then begin Result := 'German'; Exit; end; //  Deutsch
  if StShort = 'dz' then begin Result := 'Bhutani'; Exit; end;
  if StShort = 'el' then begin Result := 'Greek'; Exit; end;
  if StShort = 'en' then begin Result := 'English'; Exit; end;
  if StShort = 'eo' then begin Result := 'Esperanto'; Exit; end;
  if StShort = 'es' then begin Result := 'Spanish'; Exit; end; //Spanish
  if StShort = 'et' then begin Result := 'Estonian'; Exit; end;
  if StShort = 'eu' then begin Result := 'Basque'; Exit; end;
  if StShort = 'fa' then begin Result := 'Persian'; Exit; end;
  if StShort = 'fi' then begin Result := 'Finnish'; Exit; end; //Finnish
  if StShort = 'fj' then begin Result := 'Fiji'; Exit; end;
  if StShort = 'fo' then begin Result := 'Faroese'; Exit; end;
  if StShort = 'fr' then begin Result := 'French'; Exit; end; //French
  if StShort = 'fy' then begin Result := 'Frisian'; Exit; end;
  if StShort = 'ga' then begin Result := 'Irish'; Exit; end;
  if StShort = 'gd' then begin Result := 'Gaelic'; Exit; end;
  if StShort = 'gl' then begin Result := 'Galician'; Exit; end;
  if StShort = 'gn' then begin Result := 'Guarani'; Exit; end;
  if StShort = 'gu' then begin Result := 'Gujarati'; Exit; end;
  if StShort = 'ha' then begin Result := 'Hausa'; Exit; end;
  if StShort = 'he' then begin Result := 'Hebrew'; Exit; end; //formerly iw
  if StShort = 'hi' then begin Result := 'Hindi'; Exit; end;
  if StShort = 'hr' then begin Result := 'Croatian'; Exit; end; //Croatian
  if StShort = 'hu' then begin Result := 'Hungarian'; Exit; end; //Hungarian
  if StShort = 'hy' then begin Result := 'Armenian'; Exit; end;
  if StShort = 'ia' then begin Result := 'Interlingua'; Exit; end;
  if StShort = 'id' then begin Result := 'Indonesian'; Exit; end; //formerly in
  if StShort = 'ie' then begin Result := 'Interlingue'; Exit; end;
  if StShort = 'ik' then begin Result := 'Inupiak'; Exit; end;
  if StShort = 'in' then begin Result := 'Indonesian'; Exit; end; //replaced by id
  if StShort = 'is' then begin Result := 'Icelandic'; Exit; end; //Icelandic
  if StShort = 'it' then begin Result := 'Italian'; Exit; end; //Italian
  if StShort = 'iu' then begin Result := 'Inuktitut'; Exit; end;
  if StShort = 'iw' then begin Result := 'Hebrew'; Exit; end; //replaced by he
  if StShort = 'ja' then begin Result := 'Japanese'; Exit; end;
  if StShort = 'ji' then begin Result := 'Yiddish'; Exit; end; //replaced by yi
  if StShort = 'jw' then begin Result := 'Javanese'; Exit; end;
  if StShort = 'ka' then begin Result := 'Georgian'; Exit; end;
  if StShort = 'kk' then begin Result := 'Kazakh'; Exit; end;
  if StShort = 'kl' then begin Result := 'Greenlandic'; Exit; end;
  if StShort = 'km' then begin Result := 'Cambodian'; Exit; end;
  if StShort = 'kn' then begin Result := 'Kannada'; Exit; end;
  if StShort = 'ko' then begin Result := 'Korean'; Exit; end;
  if StShort = 'ks' then begin Result := 'Kashmiri'; Exit; end;
  if StShort = 'ku' then begin Result := 'Kurdish'; Exit; end;
  if StShort = 'ky' then begin Result := 'Kirghiz'; Exit; end;
  if StShort = 'la' then begin Result := 'Latin'; Exit; end;
  if StShort = 'ln' then begin Result := 'Lingala'; Exit; end;
  if StShort = 'lo' then begin Result := 'Laothian'; Exit; end;
  if StShort = 'lt' then begin Result := 'Lithuanian'; Exit; end;
  if StShort = 'lv' then begin Result := 'Latvian'; Exit; end;
  if StShort = 'mg' then begin Result := 'Malagasy'; Exit; end;
  if StShort = 'mi' then begin Result := 'Maori'; Exit; end;
  if StShort = 'mk' then begin Result := 'Macedonian'; Exit; end;
  if StShort = 'ml' then begin Result := 'Malayalam'; Exit; end;
  if StShort = 'mn' then begin Result := 'Mongolian'; Exit; end;
  if StShort = 'mo' then begin Result := 'Moldavian'; Exit; end;
  if StShort = 'mr' then begin Result := 'Marathi'; Exit; end;
  if StShort = 'ms' then begin Result := 'Malay'; Exit; end;
  if StShort = 'mt' then begin Result := 'Maltese'; Exit; end;
  if StShort = 'my' then begin Result := 'Burmese'; Exit; end;
  if StShort = 'na' then begin Result := 'Nauru'; Exit; end;
  if StShort = 'ne' then begin Result := 'Nepali'; Exit; end;
  if StShort = 'nl' then begin Result := 'Dutch'; Exit; end; //Dutch
  if StShort = 'no' then begin Result := 'Norwegian'; Exit; end; //Norwegian
  if StShort = 'oc' then begin Result := 'Occitan'; Exit; end;
  if StShort = 'om' then begin Result := 'Oromo'; Exit; end;
  if StShort = 'or' then begin Result := 'Oriya'; Exit; end;
  if StShort = 'pa' then begin Result := 'Punjabi'; Exit; end;
  if StShort = 'pl' then begin Result := 'Polish'; Exit; end;
  if StShort = 'ps' then begin Result := 'Pushto'; Exit; end;
  if StShort = 'pt' then begin Result := 'Portuguese'; Exit; end; //Portugese
  if StShort = 'qu' then begin Result := 'Quechua'; Exit; end;
  if StShort = 'rm' then begin Result := 'Rhaeto-Romance'; Exit; end;
  if StShort = 'rn' then begin Result := 'Kirundi'; Exit; end;
  if StShort = 'ro' then begin Result := 'Romanian'; Exit; end;
  if StShort = 'ru' then begin Result := 'Russian'; Exit; end;
  if StShort = 'rw' then begin Result := 'Kinyarwanda'; Exit; end;
  if StShort = 'sa' then begin Result := 'Sanskrit'; Exit; end;
  if StShort = 'sd' then begin Result := 'Sindhi'; Exit; end;
  if StShort = 'sg' then begin Result := 'Sangho'; Exit; end;
  if StShort = 'sh' then begin Result := 'Serbo-Croatian'; Exit; end;
  if StShort = 'si' then begin Result := 'Sinhalese'; Exit; end;
  if StShort = 'sk' then begin Result := 'Slovak'; Exit; end;
  if StShort = 'sl' then begin Result := 'Slovenian'; Exit; end;
  if StShort = 'sm' then begin Result := 'Samoan'; Exit; end;
  if StShort = 'sn' then begin Result := 'Shona'; Exit; end;
  if StShort = 'so' then begin Result := 'Somali'; Exit; end;
  if StShort = 'sq' then begin Result := 'Albanian'; Exit; end;
  if StShort = 'sr' then begin Result := 'Serbian'; Exit; end;
  if StShort = 'ss' then begin Result := 'Siswati'; Exit; end;
  if StShort = 'st' then begin Result := 'Sesotho'; Exit; end;
  if StShort = 'su' then begin Result := 'Sundanese'; Exit; end;
  if StShort = 'sv' then begin Result := 'Swedish'; Exit; end; //Swedish
  if StShort = 'sw' then begin Result := 'Swahili'; Exit; end;
  if StShort = 'ta' then begin Result := 'Tamil'; Exit; end;
  if StShort = 'te' then begin Result := 'Telugu'; Exit; end;
  if StShort = 'tg' then begin Result := 'Tajik'; Exit; end;
  if StShort = 'th' then begin Result := 'Thai'; Exit; end;
  if StShort = 'ti' then begin Result := 'Tigrinya'; Exit; end;
  if StShort = 'tk' then begin Result := 'Turkmen'; Exit; end;
  if StShort = 'tl' then begin Result := 'Tagalog'; Exit; end;
  if StShort = 'tn' then begin Result := 'Setswana'; Exit; end;
  if StShort = 'to' then begin Result := 'Tonga'; Exit; end;
  if StShort = 'tr' then begin Result := 'Turkish'; Exit; end;
  if StShort = 'ts' then begin Result := 'Tsonga'; Exit; end;
  if StShort = 'tt' then begin Result := 'Tatar'; Exit; end;
  if StShort = 'tw' then begin Result := 'Twi'; Exit; end;
  if StShort = 'ug' then begin Result := 'Uighur'; Exit; end;
  if StShort = 'uk' then begin Result := 'Ukrainian'; Exit; end;
  if StShort = 'ur' then begin Result := 'Urdu'; Exit; end;
  if StShort = 'uz' then begin Result := 'Uzbek'; Exit; end;
  if StShort = 'vi' then begin Result := 'Vietnamese'; Exit; end;
  if StShort = 'vo' then begin Result := 'Volapuk'; Exit; end;
  if StShort = 'wo' then begin Result := 'Wolof'; Exit; end;
  if StShort = 'xh' then begin Result := 'Xhosa'; Exit; end;
  if StShort = 'yi' then begin Result := 'Yiddish'; Exit; end; //formerly ji
  if StShort = 'yo' then begin Result := 'Yoruba'; Exit; end;
  if StShort = 'za' then begin Result := 'Zhuang'; Exit; end;
  if StShort = 'zh' then begin Result := 'Chinese'; Exit; end;
  if StShort = 'zu' then begin Result := 'Zulu'; Exit; end;
  Result := StShort; //unknown language
end;

function Full2ShortLanguageName(StLong: WideString): WideString;
begin
     if StLong = #0#0 then begin Result := ''; Exit; end; //none
      //ISO 639 language codes, brought from vStrip
     if StLong = 'Afar' then begin Result := 'aa'; Exit; end;
     if StLong = 'Abkhazian' then begin Result := 'ab'; Exit; end;
     if StLong = 'Afrikaans'then begin Result := 'af'; Exit; end;
     if StLong = 'Amharic' then begin Result := 'am'; Exit; end;
     if StLong = 'Arabic' then begin Result := 'ar'; Exit; end;
     if StLong = 'Assamese' then begin Result := 'as'; Exit; end;
     if StLong = 'Aymara' then begin Result := 'ay'; Exit; end;
     if StLong = 'Azerbaijani' then begin Result := 'az'; Exit; end;
     if StLong = 'Bashkir' then begin Result := 'ba'; Exit; end;
     if StLong = 'Byelorussian' then begin Result := 'be'; Exit; end;
     if StLong = 'Bulgarian' then begin Result := 'bg'; Exit; end;
     if StLong = 'Bihari' then begin Result := 'bh'; Exit; end;
     if StLong = 'Bislama' then begin Result := 'bi'; Exit; end;
     if StLong = 'Bengali' then begin Result := 'bn'; Exit; end;
     if StLong = 'Tibetan' then begin Result := 'bo'; Exit; end;
     if StLong = 'Breton' then begin Result := 'br'; Exit; end;
     if StLong = 'Catalan' then begin Result := 'ca'; Exit; end;
     if StLong = 'Corsican' then begin Result := 'co'; Exit; end;
     if StLong = 'Czech' then begin Result := 'cs'; Exit; end;
     if StLong = 'Welsh' then begin Result := 'cy'; Exit; end;
     if StLong = 'Danish' then begin Result := 'da'; Exit; end; //Danish
     if StLong = 'German' then begin Result := 'de'; Exit; end; //  Deutsch
     if StLong = 'Bhutani' then begin Result := 'dz'; Exit; end;
     if StLong = 'Greek' then begin Result := 'el'; Exit; end;
     if StLong = 'English' then begin Result := 'en'; Exit; end;
     if StLong = 'Esperanto' then begin Result := 'eo'; Exit; end;
     if StLong = 'Spanish' then begin Result := 'es'; Exit; end; //Spanish
     if StLong = 'Estonian' then begin Result := 'et'; Exit; end;
     if StLong = 'Basque' then begin Result := 'eu'; Exit; end;
     if StLong = 'Persian' then begin Result := 'fa'; Exit; end;
     if StLong = 'Finnish' then begin Result := 'fi'; Exit; end; //Finnish
     if StLong = 'Fiji' then begin Result := 'fj'; Exit; end;
     if StLong = 'Faroese' then begin Result := 'fo'; Exit; end;
     if StLong = 'French' then begin Result := 'fr'; Exit; end; //French
     if StLong = 'Frisian' then begin Result := 'fy'; Exit; end;
     if StLong = 'Irish' then begin Result := 'ga'; Exit; end;
     if StLong = 'Gaelic' then begin Result := 'gd'; Exit; end;
     if StLong = 'Galician' then begin Result := 'gl'; Exit; end;
     if StLong = 'Guarani' then begin Result := 'gn'; Exit; end;
     if StLong = 'Gujarati' then begin Result := 'gu'; Exit; end;
     if StLong = 'Hausa' then begin Result := 'ha'; Exit; end;
     if StLong = 'Hebrew' then begin Result := 'he'; Exit; end; //formerly iw
     if StLong = 'Hindi' then begin Result := 'hi'; Exit; end;
     if StLong = 'Croatian' then begin Result := 'hr'; Exit; end; //Croatian
     if StLong = 'Hungarian' then begin Result := 'hu'; Exit; end; //Hungarian
     if StLong = 'Armenian' then begin Result := 'hy'; Exit; end;
     if StLong = 'Interlingua' then begin Result := 'ia'; Exit; end;
     if StLong = 'Indonesian' then begin Result := 'id'; Exit; end; //formerly in
     if StLong = 'Interlingue' then begin Result := 'ie'; Exit; end;
     if StLong = 'Inupiak' then begin Result := 'ik'; Exit; end;
     if StLong = 'Icelandic' then begin Result := 'is'; Exit; end; //Icelandic
     if StLong = 'Italian' then begin Result := 'it'; Exit; end; //Italian
     if StLong = 'Inuktitut' then begin Result := 'iu'; Exit; end;
     if StLong = 'Hebrew' then begin Result := 'iw'; Exit; end; //replaced by he
     if StLong = 'Japanese' then begin Result := 'ja'; Exit; end;
     if StLong = 'Yiddish' then begin Result := 'ji'; Exit; end; //replaced by yi
     if StLong = 'Javanese' then begin Result := 'jw'; Exit; end;
     if StLong = 'Georgian' then begin Result := 'ka'; Exit; end;
     if StLong = 'Kazakh' then begin Result := 'kk'; Exit; end;
     if StLong = 'Greenlandic' then begin Result := 'kl'; Exit; end;
     if StLong = 'Cambodian' then begin Result := 'km'; Exit; end;
     if StLong = 'Kannada' then begin Result := 'kn'; Exit; end;
     if StLong = 'Korean' then begin Result := 'ko'; Exit; end;
     if StLong = 'Kashmiri' then begin Result := 'ks'; Exit; end;
     if StLong = 'Kurdish' then begin Result := 'ku'; Exit; end;
     if StLong = 'Kirghiz' then begin Result := 'ky'; Exit; end;
     if StLong = 'Latin' then begin Result := 'la'; Exit; end;
     if StLong = 'Lingala' then begin Result := 'ln'; Exit; end;
     if StLong = 'Laothian' then begin Result := 'lo'; Exit; end;
     if StLong = 'Lithuanian' then begin Result := 'lt'; Exit; end;
     if StLong = 'Latvian' then begin Result := 'lv'; Exit; end;
     if StLong = 'Malagasy' then begin Result := 'mg'; Exit; end;
     if StLong = 'Maori' then begin Result := 'mi'; Exit; end;
     if StLong = 'Macedonian' then begin Result := 'mk'; Exit; end;
     if StLong = 'Malayalam' then begin Result := 'ml'; Exit; end;
     if StLong = 'Mongolian' then begin Result := 'mn'; Exit; end;
     if StLong = 'Moldavian' then begin Result := 'mo'; Exit; end;
     if StLong = 'Marathi' then begin Result := 'mr'; Exit; end;
     if StLong = 'Malay' then begin Result := 'ms'; Exit; end;
     if StLong = 'Maltese' then begin Result := 'mt'; Exit; end;
     if StLong = 'Burmese' then begin Result := 'my'; Exit; end;
     if StLong = 'Nauru' then begin Result := 'na'; Exit; end;
     if StLong = 'Nepali' then begin Result := 'ne'; Exit; end;
     if StLong = 'Dutch' then begin Result := 'nl'; Exit; end; //Dutch
     if StLong = 'Norwegian' then begin Result := 'no'; Exit; end; //Norwegian
     if StLong = 'Occitan' then begin Result := 'oc'; Exit; end;
     if StLong = 'Oromo' then begin Result := 'om'; Exit; end;
     if StLong = 'Oriya' then begin Result := 'or'; Exit; end;
     if StLong = 'Punjabi' then begin Result := 'pa'; Exit; end;
     if StLong = 'Polish' then begin Result := 'pl'; Exit; end;
     if StLong = 'Pushto' then begin Result := 'ps'; Exit; end;
     if StLong = 'Portuguese' then begin Result := 'pt'; Exit; end; //Portugese
     if StLong = 'Quechua' then begin Result := 'qu'; Exit; end;
     if StLong = 'Kirundi' then begin Result := 'rn'; Exit; end;
     if StLong = 'Romanian' then begin Result := 'ro'; Exit; end;
     if StLong = 'Russian' then begin Result := 'ru'; Exit; end;
     if StLong = 'Kinyarwanda' then begin Result := 'rw'; Exit; end;
     if StLong = 'Sanskrit' then begin Result := 'sa'; Exit; end;
     if StLong = 'Sindhi' then begin Result := 'sd'; Exit; end;
     if StLong = 'Sangho' then begin Result := 'sg'; Exit; end;
     if StLong = 'Serbo-Croatian' then begin Result := 'sh'; Exit; end;
     if StLong = 'Sinhalese' then begin Result := 'si'; Exit; end;
     if StLong = 'Slovak' then begin Result := 'sk'; Exit; end;
     if StLong = 'Slovenian' then begin Result := 'sl'; Exit; end;
     if StLong = 'Samoan' then begin Result := 'sm'; Exit; end;
     if StLong = 'Shona' then begin Result := 'sn'; Exit; end;
     if StLong = 'Somali' then begin Result := 'so'; Exit; end;
     if StLong = 'Albanian' then begin Result := 'sq'; Exit; end;
     if StLong = 'Serbian' then begin Result := 'sr'; Exit; end;
     if StLong = 'Siswati' then begin Result := 'ss'; Exit; end;
     if StLong = 'Sesotho' then begin Result := 'st'; Exit; end;
     if StLong = 'Sundanese' then begin Result := 'su'; Exit; end;
     if StLong = 'Swedish' then begin Result := 'sv'; Exit; end; //Swedish
     if StLong = 'Swahili' then begin Result := 'sw'; Exit; end;
     if StLong = 'Tamil' then begin Result := 'ta'; Exit; end;
     if StLong = 'Telugu' then begin Result := 'te'; Exit; end;
     if StLong = 'Tajik' then begin Result := 'tg'; Exit; end;
     if StLong = 'Thai' then begin Result := 'th'; Exit; end;
     if StLong = 'Tigrinya' then begin Result := 'ti'; Exit; end;
     if StLong = 'Turkmen' then begin Result := 'tk'; Exit; end;
     if StLong = 'Tagalog' then begin Result := 'tl'; Exit; end;
     if StLong = 'Setswana' then begin Result := 'tn'; Exit; end;
     if StLong = 'Tonga' then begin Result := 'to'; Exit; end;
     if StLong = 'Turkish' then begin Result := 'tr'; Exit; end;
     if StLong = 'Tsonga' then begin Result := 'ts'; Exit; end;
     if StLong = 'Tatar' then begin Result := 'tt'; Exit; end;
     if StLong = 'Twi' then begin Result := 'tw'; Exit; end;
     if StLong = 'Uighur' then begin Result := 'ug'; Exit; end;
     if StLong = 'Ukrainian' then begin Result := 'uk'; Exit; end;
     if StLong = 'Urdu' then begin Result := 'ur'; Exit; end;
     if StLong = 'Uzbek' then begin Result := 'uz'; Exit; end;
     if StLong = 'Vietnamese' then begin Result := 'vi'; Exit; end;
     if StLong = 'Volapuk' then begin Result := 'vo'; Exit; end;
     if StLong = 'Wolof' then begin Result := 'wo'; Exit; end;
     if StLong = 'Xhosa' then begin Result := 'xh'; Exit; end;
     if StLong = 'Yiddish' then begin Result := 'yi'; Exit; end; //formerly ji
     if StLong = 'Yoruba' then begin Result := 'yo'; Exit; end;
     if StLong = 'Zhuang' then begin Result := 'za'; Exit; end;
     if StLong = 'Chinese' then begin Result := 'zh'; Exit; end;
     if StLong = 'Zulu' then begin Result := 'zu'; Exit; end;
 // Result := StShort; //unknown language
end;


function Lang2Nbr(Lang: WideString): Integer;
begin
     if Lang = 'Abkhazian' then Result := 1
     else if Lang = 'Afar' then Result := 2
     else if Lang = 'Afrikaans' then Result := 3
     else if Lang = 'Albanian' then Result := 4
     else if Lang = 'Arabic' then Result := 5
     else if Lang = 'Armenian' then Result := 6
     else if Lang = 'Australian' then Result := 7
     else if Lang = 'Basque' then Result := 8
     else if Lang = 'Belarusian' then Result := 9
     else if Lang = 'Bengali' then Result := 10
     else if Lang = 'Berber' then Result := 11
     else if Lang = 'Bosnian' then Result := 12
     else if Lang = 'Breton' then Result := 13
     else if Lang = 'Bulgarian' then Result := 14
     else if Lang = 'Castilian' then Result := 15
     else if Lang = 'Catalan' then Result := 16
     else if Lang = 'Caucasian' then Result := 17
     else if Lang = 'Celtic' then Result := 18
     else if Lang = 'Chinese' then Result := 19
     else if Lang = 'Corsican' then Result := 20
     else if (Lang = 'Croatian') or (Lang = 'Hrvatski') then Result := 21
     else if Lang = 'Czech' then Result := 22
     else if (Lang = 'Danish') or (Lang = 'Dansk') then Result := 23
     else if (Lang = 'Dutch') or (Lang = 'Nederlands') then Result := 24
     else if Lang = 'English' then Result := 25
     else if Lang = 'Estonian' then Result := 26
     else if Lang = 'Faorese' then Result := 27
     else if (Lang = 'Finnish') or (Lang = 'Suomi') then Result := 28
     else if Lang = 'French' then Result := 29
     else if Lang = 'Gaelic' then Result := 30
     else if Lang = 'Georgian' then Result := 31
     else if (Lang = 'German') or (Lang = 'Deutsch') then Result := 32
     else if Lang = 'Greek' then Result := 33
     else if Lang = 'Haitian' then Result := 34
     else if Lang = 'Hawaiian' then Result := 35
     else if Lang = 'Hebrew' then Result := 36
     else if Lang = 'Hindi' then Result := 37
     else if (Lang = 'Hungarian') or (Lang = 'Magyar') then Result := 38
     else if (Lang = 'Icelandic') or (Lang = 'Islenska') then Result := 39
     else if Lang = 'Indonesian' then Result := 40
     else if Lang = 'Iranian' then Result := 41
     else if Lang = 'Irish' then Result := 42
     else if (Lang = 'Italian') or (Lang = 'Italiano') then Result := 43
     else if Lang = 'Japanese' then Result := 44
     else if Lang = 'Kabyle' then Result := 45
     else if Lang = 'Kazakh' then Result := 46
     else if Lang = 'Kirghiz' then Result := 47
     else if Lang = 'Korean' then Result := 48
     else if Lang = 'Latvian' then Result := 49
     else if Lang = 'Lithuanian' then Result := 50
     else if Lang = 'Luxembourgish' then Result := 51
     else if Lang = 'Macedonian' then Result := 52
     else if Lang = 'Malay' then Result := 53
     else if Lang = 'Moldavian' then Result := 54
     else if Lang = 'Mongolian' then Result := 55
     else if (Lang = 'Norwegian') or (Lang = 'Norsk') then Result := 56
     else if Lang = 'Occitan' then Result := 57
     else if Lang = 'Polish' then Result := 58
     else if (Lang = 'Portuguese') or (Lang = 'Portugues') then Result := 59
     else if Lang = 'Romanian' then Result := 60
     else if Lang = 'Russian' then Result := 61
     else if Lang = 'Scottish' then Result := 62
     else if Lang = 'Serbian' then Result := 63
     else if Lang = 'Serbo-Croatian' then Result := 64
     else if Lang = 'Slovak' then Result := 65
     else if Lang = 'Slovenian' then Result := 66
     else if (Lang = 'Spanish') or (Lang = 'Espanol') then Result := 67
     else if Lang = 'Swahili' then Result := 68
     else if (Lang = 'Swedish') or (Lang = 'Svenska') then Result := 69
     else if Lang = 'Tahitian' then Result := 70
     else if Lang = 'Thai' then Result := 71
     else if Lang = 'Tibetan' then Result := 72
     else if Lang = 'Turkish' then Result := 73
     else if Lang = 'Ukrainian' then Result := 74
     else if Lang = 'Vietnamese' then Result := 75
     else if Lang = 'Welsh' then Result := 76
     else Result := 0;
end;

function CheckMP4FileExt(FileName: WideString): Boolean;
begin
          if WideExtractFileExt(FileName) = '.avi' then Result := True
     else if WideExtractFileExt(FileName) = '.mp4' then Result := True
     else if WideExtractFileExt(FileName) = '.m4a' then Result := True
     else if WideExtractFileExt(FileName) = '.m4b' then Result := True
     else if WideExtractFileExt(FileName) = '.mov' then Result := True
     else if WideExtractFileExt(FileName) = '.aac' then Result := True
     else if WideExtractFileExt(FileName) = '.amr' then Result := True
     else if WideExtractFileExt(FileName) = '.awb' then Result := True
     else if WideExtractFileExt(FileName) = '.evc' then Result := True
     else if WideExtractFileExt(FileName) = '.smv' then Result := True
     else if WideExtractFileExt(FileName) = '.ogg' then Result := True
     else if WideExtractFileExt(FileName) = '.vob' then Result := True
     else if WideExtractFileExt(FileName) = '.mpeg' then Result := True
     else if WideExtractFileExt(FileName) = '.mpg' then Result := True
     else if WideExtractFileExt(FileName) = '.vcd' then Result := True
     else if WideExtractFileExt(FileName) = '.ts' then Result := True
     else if WideExtractFileExt(FileName) = '.mp3' then Result := True
     else if WideExtractFileExt(FileName) = '.mp2' then Result := True
     else if WideExtractFileExt(FileName) = '.h264' then Result := True
     else if WideExtractFileExt(FileName) = '.264' then Result := True
     else if WideExtractFileExt(FileName) = '.h263' then Result := True
     else if WideExtractFileExt(FileName) = '.263' then Result := True
     else if WideExtractFileExt(FileName) = '.3gp' then Result := True
     else if WideExtractFileExt(FileName) = '.3g2' then Result := True
     else if WideExtractFileExt(FileName) = '.m1v' then Result := True
     else if WideExtractFileExt(FileName) = '.m2v' then Result := True
     else if WideExtractFileExt(FileName) = '.m4v' then Result := True
     else if WideExtractFileExt(FileName) = '.cmp' then Result := True
     else if WideExtractFileExt(FileName) = '.txt' then Result := True
     else if WideExtractFileExt(FileName) = '.srt' then Result := True
     else if WideExtractFileExt(FileName) = '.ttxt' then Result := True
     else if WideExtractFileExt(FileName) = '.xml' then Result := True
     else if WideExtractFileExt(FileName) = '.idx' then Result := True
     else if WideExtractFileExt(FileName) = '.nhnt' then Result := True
     else if WideExtractFileExt(FileName) = '.nhml' then Result := True
     else if WideExtractFileExt(FileName) = '.info' then Result := True
     else if WideExtractFileExt(FileName) = '.media' then Result := True
     else if WideExtractFileExt(FileName) = '.jpeg' then Result := True
     else if WideExtractFileExt(FileName) = '.jpg' then Result := True
     else if WideExtractFileExt(FileName) = '.qcp' then Result := True
     else Result := False;
end;

function Check3GPPFileExt(FileName: WideString): Boolean;
begin
          if WideExtractFileExt(FileName) = '.avi' then Result := True
     else if WideExtractFileExt(FileName) = '.mp4' then Result := True
     else if WideExtractFileExt(FileName) = '.m4a' then Result := True
     else if WideExtractFileExt(FileName) = '.m4b' then Result := True
     else if WideExtractFileExt(FileName) = '.mov' then Result := True
     else if WideExtractFileExt(FileName) = '.aac' then Result := True
     else if WideExtractFileExt(FileName) = '.amr' then Result := True
     else if WideExtractFileExt(FileName) = '.awb' then Result := True
     else if WideExtractFileExt(FileName) = '.evc' then Result := True
     else if WideExtractFileExt(FileName) = '.smv' then Result := True
     else if WideExtractFileExt(FileName) = '.vob' then Result := True
     else if WideExtractFileExt(FileName) = '.mpeg' then Result := True
     else if WideExtractFileExt(FileName) = '.mpg' then Result := True
     else if WideExtractFileExt(FileName) = '.vcd' then Result := True
     else if WideExtractFileExt(FileName) = '.mp3' then Result := True
     else if WideExtractFileExt(FileName) = '.h264' then Result := True
     else if WideExtractFileExt(FileName) = '.264' then Result := True
     else if WideExtractFileExt(FileName) = '.h263' then Result := True
     else if WideExtractFileExt(FileName) = '.263' then Result := True
     else if WideExtractFileExt(FileName) = '.3gp' then Result := True
     else if WideExtractFileExt(FileName) = '.3g2' then Result := True
     else if WideExtractFileExt(FileName) = '.m1v' then Result := True
     else if WideExtractFileExt(FileName) = '.m2v' then Result := True
     else if WideExtractFileExt(FileName) = '.m4v' then Result := True
     else if WideExtractFileExt(FileName) = '.cmp' then Result := True
     else if WideExtractFileExt(FileName) = '.txt' then Result := True
     else if WideExtractFileExt(FileName) = '.srt' then Result := True
     else if WideExtractFileExt(FileName) = '.ttxt' then Result := True
     else if WideExtractFileExt(FileName) = '.xml' then Result := True
     else if WideExtractFileExt(FileName) = '.jpeg' then Result := True
     else if WideExtractFileExt(FileName) = '.jpg' then Result := True
     else Result := False;
end;

function CheckCatFileExt(FileName: WideString): Boolean;
begin
          if WideExtractFileExt(FileName) = '.avi' then Result := True
     else if WideExtractFileExt(FileName) = '.mp4' then Result := True
     else if WideExtractFileExt(FileName) = '.m4a' then Result := True
     else if WideExtractFileExt(FileName) = '.m4b' then Result := True
     else if WideExtractFileExt(FileName) = '.mov' then Result := True
     else if WideExtractFileExt(FileName) = '.aac' then Result := True
     else if WideExtractFileExt(FileName) = '.amr' then Result := True
     else if WideExtractFileExt(FileName) = '.awb' then Result := True
     else if WideExtractFileExt(FileName) = '.evc' then Result := True
     else if WideExtractFileExt(FileName) = '.smv' then Result := True
     else if WideExtractFileExt(FileName) = '.vob' then Result := True
     else if WideExtractFileExt(FileName) = '.mpeg' then Result := True
     else if WideExtractFileExt(FileName) = '.mpg' then Result := True
     else if WideExtractFileExt(FileName) = '.vcd' then Result := True
     else if WideExtractFileExt(FileName) = '.mp3' then Result := True
     else if WideExtractFileExt(FileName) = '.h264' then Result := True
     else if WideExtractFileExt(FileName) = '.264' then Result := True
     else if WideExtractFileExt(FileName) = '.h263' then Result := True
     else if WideExtractFileExt(FileName) = '.263' then Result := True
     else if WideExtractFileExt(FileName) = '.3gp' then Result := True
     else if WideExtractFileExt(FileName) = '.3g2' then Result := True
     else if WideExtractFileExt(FileName) = '.m1v' then Result := True
     else if WideExtractFileExt(FileName) = '.m2v' then Result := True
     else if WideExtractFileExt(FileName) = '.m4v' then Result := True
     else if WideExtractFileExt(FileName) = '.cmp' then Result := True
     else Result := False;
end;

procedure ExchangeItems(lv: TTntListView; const ItemFrom, ItemTo: Cardinal);
var Source, Target: TListItem;
begin
  lv.Items.BeginUpdate;
  try
    Source := lv.Items[ItemFrom];
    Target := lv.Items.Insert(ItemTo);
    Target.Assign(Source);
    Source.Free;
  finally
    lv.Items.EndUpdate;
  end;
end;

procedure SetVistaFonts(const AForm: TCustomForm);
var Size: Integer;
begin
  if not SameText(AForm.Font.Name, VistaFont) then
  begin
    Size := AForm.Font.Size;
    if not SameText(AForm.Font.Name, VistaFont) then
      Inc(Size, 1);
    AForm.Font.Name := VistaFont;
    if not SameText(AForm.Font.Name, VistaFont) then
      AForm.Font.Name := XPFont
    else
      AForm.Font.Size := Size;
  end;
end;

function IsWindowsVista: Boolean;
var
  VerInfo: TOSVersioninfo;
begin
  VerInfo.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
  GetVersionEx(VerInfo);        
  Result := (VerInfo.dwMajorVersion = 6) and (VerInfo.dwMinorVersion = 0);
end;

function CharReplace(const Source: string; oldChar, newChar: Char): string;
var
  i: Integer;
begin
  Result := Source;
  for i := 1 to Length(Result) do
    if Result[i] = oldChar then
      Result[i] := newChar
end;

const
  dwmapi = 'dwmapi.dll';
  DwmIsCompositionEnabledSig = 'DwmIsCompositionEnabled';
  DwmExtendFrameIntoClientAreaSig = 'DwmExtendFrameIntoClientArea';
  TaskDialogSig = 'TaskDialog';

function CompositingEnabled: Boolean;
var
  DLLHandle: THandle;
  DwmIsCompositionEnabledProc: function(pfEnabled: PBoolean): HRESULT; stdcall;
  Enabled: Boolean;
begin
  Result := False;
  if IsWindowsVista then
  begin
    DLLHandle := LoadLibrary(dwmapi);

    if DLLHandle <> 0 then 
    begin
      @DwmIsCompositionEnabledProc := GetProcAddress(DLLHandle,
        DwmIsCompositionEnabledSig);

      if (@DwmIsCompositionEnabledProc <> nil) then
      begin
        DwmIsCompositionEnabledProc(@Enabled);
        Result := Enabled;
      end;

      FreeLibrary(DLLHandle);
    end;
  end;
end;

//from http://www.delphipraxis.net/topic93221,next.html
procedure ExtendGlass(const AHandle: THandle; const AMargins: TRect);
type
  _MARGINS = packed record 
    cxLeftWidth: Integer; 
    cxRightWidth: Integer; 
    cyTopHeight: Integer; 
    cyBottomHeight: Integer; 
  end; 
  PMargins = ^_MARGINS; 
  TMargins = _MARGINS; 
var 
  DLLHandle: THandle;
  DwmExtendFrameIntoClientAreaProc: function(destWnd: HWND; const pMarInset: 
    PMargins): HRESULT; stdcall;
  Margins: TMargins;
begin
  if IsWindowsVista and CompositingEnabled then
  begin
    DLLHandle := LoadLibrary(dwmapi);

    if DLLHandle <> 0 then
    begin
      @DwmExtendFrameIntoClientAreaProc := GetProcAddress(DLLHandle,
        DwmExtendFrameIntoClientAreaSig);

      if (@DwmExtendFrameIntoClientAreaProc <> nil) then
      begin
        ZeroMemory(@Margins, SizeOf(Margins));
        Margins.cxLeftWidth := AMargins.Left;
        Margins.cxRightWidth := AMargins.Right;
        Margins.cyTopHeight := AMargins.Top;
        Margins.cyBottomHeight := AMargins.Bottom;

        DwmExtendFrameIntoClientAreaProc(AHandle, @Margins);
      end;

      FreeLibrary(DLLHandle);
    end;
  end;
end;

function OpenSaveFileDialog(ParentHandle: THandle; const DefExt, Filter, InitialDir, Title: string; var FileName: string;
  MustExist, OverwritePrompt, NoChangeDir, DoOpen, MultiSelect: Boolean): Boolean;
var
  ofn: TOpenFileName;
  szFile: array[0..MAX_PATH] of Char;
begin
  Result := False;
  FillChar(ofn, SizeOf(TOpenFileName), 0);
  with ofn do
  begin
    lStructSize := SizeOf(TOpenFileName);
    hwndOwner := ParentHandle;
    lpstrFile := szFile;
    nMaxFile := SizeOf(szFile);
    if (Title <> '') then
      lpstrTitle := PChar(Title);
    if (InitialDir <> '') then
      lpstrInitialDir := PChar(InitialDir);
    StrPCopy(lpstrFile, FileName);
    lpstrFilter := PChar(CharReplace(Filter, '|', #0)+#0#0);
    if DefExt <> '' then
      lpstrDefExt := PChar(DefExt);
  end;

  if MustExist then
    ofn.Flags := ofn.Flags or OFN_FILEMUSTEXIST;

  if OverwritePrompt then
    ofn.Flags := ofn.Flags or OFN_OVERWRITEPROMPT;

  if NoChangeDir then
    ofn.Flags := ofn.Flags or OFN_NOCHANGEDIR;

  if MultiSelect then
    ofn.Flags := ofn.Flags or OFN_ALLOWMULTISELECT;

  if DoOpen then
  begin
    if GetOpenFileName(ofn) then
    begin
      Result := True;
      FileName := StrPas(szFile);
    end;
  end
  else
  begin
    if GetSaveFileName(ofn) then
    begin
      Result := True;
      FileName := StrPas(szFile);
    end;
  end
end;

//from http://www.tmssoftware.com/atbdev5.htm
function TaskDialog(const AHandle: THandle; const ATitle, ADescription,
  AContent: string; const Icon, Buttons: Integer): Integer;
var
  DLLHandle: THandle;
  res: integer;
  S: string;
  wTitle, wDescription, wContent: array[0..1024] of widechar;
  Btns: TMsgDlgButtons;
  DlgType: TMsgDlgType;
  TaskDialogProc: function(HWND: THandle; hInstance: THandle; cTitle,
    cDescription, cContent: pwidechar; Buttons: Integer; Icon: integer;
    ResButton: pinteger): integer; cdecl stdcall;
begin
  Result := 0;
  if IsWindowsVista then
  begin
    DLLHandle := LoadLibrary(comctl32);
    if DLLHandle >= 32 then
    begin
      @TaskDialogProc := GetProcAddress(DLLHandle, TaskDialogSig);

      if Assigned(TaskDialogProc) then
      begin
        StringToWideChar(ATitle, wTitle, SizeOf(wTitle));
        StringToWideChar(ADescription, wDescription, SizeOf(wDescription));

        //Get rid of line breaks, may be here for backwards compat but not
        //needed with Task Dialogs
        S := StringReplace(AContent, #10, '', [rfReplaceAll]);
        S := StringReplace(S, #13, '', [rfReplaceAll]);
        StringToWideChar(S, wContent, SizeOf(wContent));

        TaskDialogProc(AHandle, 0, wTitle, wDescription, wContent, Buttons,
          Icon, @res);

        Result := mrOK;

        case res of
          TD_RESULT_CANCEL : Result := mrCancel;
          TD_RESULT_RETRY : Result := mrRetry;
          TD_RESULT_YES : Result := mrYes;
          TD_RESULT_NO : Result := mrNo;
          TD_RESULT_CLOSE : Result := mrAbort;
        end;
      end;
      FreeLibrary(DLLHandle);
    end;
  end else
  begin
    Btns := [];
    if Buttons and TD_BUTTON_OK = TD_BUTTON_OK then
      Btns := Btns + [MBOK];

    if Buttons and TD_BUTTON_YES = TD_BUTTON_YES then
      Btns := Btns + [MBYES];

    if Buttons and TD_BUTTON_NO = TD_BUTTON_NO then
      Btns := Btns + [MBNO];

    if Buttons and TD_BUTTON_CANCEL = TD_BUTTON_CANCEL then
      Btns := Btns + [MBCANCEL];

    if Buttons and TD_BUTTON_RETRY = TD_BUTTON_RETRY then
      Btns := Btns + [MBRETRY];

    if Buttons and TD_BUTTON_CLOSE = TD_BUTTON_CLOSE then
      Btns := Btns + [MBABORT];

    DlgType := mtCustom;

    case Icon of
      TD_ICON_WARNING : DlgType := mtWarning;
      TD_ICON_QUESTION : DlgType := mtConfirmation;
      TD_ICON_ERROR : DlgType := mtError;
      TD_ICON_INFORMATION: DlgType := mtInformation;
    end;

    Result := MessageDlg(AContent, DlgType, Btns, 0);
  end;
end;

function FormatFileSize(const FileSize: Int64): String;
begin
  { Get formatted file size }
  if FileSize > 0 then
    // 1024 * 1024 = 1048576
    Result := FormatFloat('0', FileSize / 1048576)
  else
    Result := FormatFloat('0', 0);
end;

function rSI(ident: WideString; default: WideString = ''): WideString;
var s,p: WideString;
begin
     p := 'MainForm';
     s := aIniFile.ReadString(p, ident, default);
     result := s;
end;

function rSI2(ident: WideString; default: WideString = ''): WideString;
var s,p: WideString;
begin
     p := 'SettingsPage';
     s := aIniFile.ReadString(p, ident, default);
     result := s;
end;

function rSI3(ident: WideString; default: WideString = ''): WideString;
var s,p: WideString;
begin
     p := 'AboutPage';
     s := aIniFile.ReadString(p, ident, default);
     result := s;
end;

function rSI4(ident: WideString; default: WideString = ''): WideString;
var s : WideString;
begin
     s := aIniFile.ReadString('MuxPage', ident, default);
     result := s;
end;

function rSI5(ident: WideString; default: WideString = ''): WideString;
var s : WideString;
begin
     s := aIniFile.ReadString('ProcessPage', ident, default);
     result := s;
end;

function rSI6(ident: WideString; default: WideString = ''): WideString;
var s : WideString;
begin
     s := aIniFile.ReadString('SplitPage', ident, default);
     result := s;
end;

function rSI7(ident: WideString; default: WideString = ''): WideString;
var s : WideString;
begin
     s := aIniFile.ReadString('ExtractPage', ident, default);
     result := s;
end;

function rSI8(ident: WideString; default: WideString = ''): WideString;
var s : WideString;
begin
     s := aIniFile.ReadString('Properties', ident, default);
     result := s;
end;

function rSI9(ident: WideString; default: WideString = ''): WideString;
var s : WideString;
begin
     s := aIniFile.ReadString('ConcatPage', ident, default);
     result := s;
end;

function rSI10(ident: WideString; default: WideString = ''): WideString;
var s : WideString;
begin
     s := aIniFile.ReadString('ConverterPage', ident, default);
     result := s;
end;

function GetCovr(FileName : WideString) : Boolean;
var Handle : Cardinal;
begin
     Handle := MediaInfo_New();
     MediaInfo_Open(Handle,PWideChar(FileName));
     if (MediaInfoA_Get(Handle, 0, 0, 'Covr', 1, 0) = 'Unknown kind of value!') or
        (MediaInfoA_Get(Handle, 0, 0, 'Covr', 1, 0) = '(Image)') then
          Result := True
     else Result := False;
     MediaInfo_Close(Handle);
end;

function GetTitle(FileName : WideString) : WideString;
var Handle : Cardinal;
begin
     Handle := MediaInfo_New();
     MediaInfo_Open(Handle,PWideChar(FileName));
     if MediaInfo_Get(Handle, 0, 0, 'Title', 1, 0) <> '' then
          Result := MediaInfo_Get(Handle, 0, 0, 'Title', 1, 0)
     else Result := '';
     MediaInfo_Close(Handle);
end;

function GetArtist(FileName: WideString) : WideString;
var Handle : Cardinal;
begin
     Handle := MediaInfo_New();
     MediaInfo_Open(Handle,PWideChar(FileName));
     if MediaInfo_Get(Handle, 0, 0, 'Artist', 1, 0) <> '' then
          Result := MediaInfo_Get(Handle, 0, 0, 'Artist', 1, 0)
     else Result := '';
     MediaInfo_Close(Handle);
end;

function GetAlbum(FileName : WideString) : WideString;
var Handle : Cardinal;
begin
     Handle := MediaInfo_New();
     MediaInfo_Open(Handle,PWideChar(FileName));
     if MediaInfo_Get(Handle, 0, 0, 'Album', 1, 0) <> '' then
          Result := MediaInfo_Get(Handle, 0, 0, 'Album', 1, 0)
     else Result := '';
     MediaInfo_Close(Handle);
end;

function GetYear(FileName : WideString) : WideString;
var Handle : Cardinal;
begin
     Handle := MediaInfo_New();
     MediaInfo_Open(Handle,PWideChar(FileName));
     if MediaInfo_Get(Handle, 0, 0, 'Encoded_Date', 1, 0) <> '' then
          Result := MediaInfo_Get(Handle, 0, 0, 'Encoded_Date', 1, 0)
     else Result := '';
     MediaInfo_Close(Handle);
end;

function GetDuration(FileName : WideString) : WideString;
var Handle : Cardinal;
begin
     Handle := MediaInfo_New();
     MediaInfo_Open(Handle,PWideChar(FileName));
     if MediaInfo_Get(Handle, 0, 0, 'PlayTime/String3', 1, 0) <> '' then
      begin
            if Pos('00:',MediaInfo_Get(Handle, 0, 0, 'PlayTime/String3', 1, 0)) > 0 then
                  Result := right('00:', MediaInfo_Get(Handle, 0, 0, 'PlayTime/String3', 1, 0))
            else  Result := MediaInfo_Get(Handle, 0, 0, 'PlayTime/String3', 1, 0);
      end
     else Result := '';
     MediaInfo_Close(Handle);
end;

function GetGenre(FileName : WideString): WideString;
var Handle : Cardinal;
begin
     Handle := MediaInfo_New();
     MediaInfo_Open(Handle,PWideChar(FileName));
     if MediaInfo_Get(Handle, 0, 0, 'Genre', 1, 0) <> '' then
          Result := MediaInfo_Get(Handle, 0, 0, 'Genre', 1, 0)
     else Result := '';
     MediaInfo_Close(Handle);
end;

procedure AddFileForShellTV(FileName: WideString);
var ListItem : TTntListItem;
    myPath : WideString;
    Handle : Cardinal;
begin
     ListItem := MainForm.FilesTagList.Items.Add;
     if right(':\', MainForm.LsDirTree211.SelectedPath) = '' then
        myPath := MainForm.LsDirTree211.SelectedPath
     else myPath := MainForm.LsDirTree211.SelectedPath+'\';

     Handle := MediaInfo_New();
     MediaInfo_Open(Handle,PWideChar(myPath+FileName));
     ListItem.SubItems.Add(myPath);  // Path
     ListItem.SubItems.Add(WideExtractFileName(FileName)); // FileName
     if MediaInfo_Get(Handle, 0, 0, 'Title', 1, 0) <> '' then
          ListItem.SubItems.Add(MediaInfo_Get(Handle, 0, 0, 'Title', 1, 0))
     else ListItem.SubItems.Add('');
    // ListItem.SubItems.Add(GetTitle(myPath+FileName)); // Name of the Song
     if MediaInfo_Get(Handle, 0, 0, 'PlayTime/String3', 1, 0) <> '' then
       begin
            if Pos('00:',MediaInfo_Get(Handle, 0, 0, 'PlayTime/String3', 1, 0)) > 0 then
                  ListItem.SubItems.Add(right('00:', MediaInfo_Get(Handle, 0, 0, 'PlayTime/String3', 1, 0)))
            else  ListItem.SubItems.Add(MediaInfo_Get(Handle, 0, 0, 'PlayTime/String3', 1, 0));
       end;
     Application.ProcessMessages;
  //   ListItem.SubItems.Add(GetDuration(myPath+FileName)); // Time
     if MediaInfo_Get(Handle, 0, 0, 'Artist', 1, 0) <> '' then
   //  ListItem.SubItems.Add(GetArtist(myPath+FileName)); // Artist
          ListItem.SubItems.Add(MediaInfo_Get(Handle, 0, 0, 'Artist', 1, 0))
     else ListItem.SubItems.Add('');
     if MediaInfo_Get(Handle, 0, 0, 'Album', 1, 0) <> '' then
  //   ListItem.SubItems.Add(GetAlbum(myPath+FileName)); // Album
           ListItem.SubItems.Add(MediaInfo_Get(Handle, 0, 0, 'Album', 1, 0))
     else  ListItem.SubItems.Add('');
     if MediaInfo_Get(Handle, 0, 0, 'Encoded_Date', 1, 0) <> '' then
   //  ListItem.SubItems.Add(GetYear(myPath+FileName)); // Year
          ListItem.SubItems.Add(MediaInfo_Get(Handle, 0, 0, 'Encoded_Date', 1, 0))
     else ListItem.SubItems.Add('');
     if MediaInfo_Get(Handle, 0, 0, 'Genre', 1, 0) <> '' then
  //   ListItem.SubItems.Add(GetGenre(myPath+FileName)); // Genre
          ListItem.SubItems.Add(MediaInfo_Get(Handle, 0, 0, 'Genre', 1, 0))
     else ListItem.SubItems.Add('');
     ListItem.SubItems.Add('');   // Writer
     ListItem.SubItems.Add('');   // TrackP
     ListItem.SubItems.Add('');   // TrackT
     ListItem.SubItems.Add('');   // DiskP
     ListItem.SubItems.Add('');   // DiskT
     ListItem.SubItems.Add('');   // Group
     ListItem.SubItems.Add('');   // Tempo
     ListItem.SubItems.Add('');   // Composer
     ListItem.SubItems.Add('');   // Compile
     ListItem.SubItems.Add('');   // Gapless
     ListItem.SubItems.Add('');   // Encoder
     ListItem.SubItems.Add('');   // Tool
     ListItem.SubItems.Add('');   // Comments
     ListItem.Checked := True;
     MainForm.FilesTagList.ItemIndex := 0;
     MediaInfo_Close(Handle);
end;

function CheckListBoxItems(ListView: TTntListView): boolean;
var i,j: Integer;
    ListItem : TTntListItem;
begin
     j:=0;
     for i:=0 to ListView.Items.Count-1 do
       begin
            ListItem := ListView.Items.Item[i];
            if (ListItem.Checked) then
              inc(j);
       end;
      if j=0 then Result := False else Result := True;
end;

function CheckListViewBrandNameItems(ListView: TTntListView; Column : Integer): boolean;
var i, k : Integer;
    ListItem : TTntListItem;
begin
     k:=0;
     for i:=0 to ListView.Items.Count-1 do
       begin
             if ListView.Selected.SubItems[Column] = 'avc1' then inc(k);
       end;
      if k>1 then Result := False else Result := True;
end;

procedure LoadIniStrings(iniLangFile: WideString);
begin
     aIniFile := TIniFile.Create(iniLangFile);
     with aIniFile do
         try
            //MainForm
            MainForm.Wizard.ButtonHelp.Caption := rSI('Help');
            MainForm.Wizard.ButtonBack.Caption := rSI('Back');
            MainForm.Wizard.ButtonNext.Caption := rSI('Next');
            MainForm.Wizard.ButtonCancel.Caption := rSI('Cancel');
            MainForm.Wizard.ButtonFinish.Caption := rSI('Finish');
            MainForm.MainList.Items.Item[0].Caption := rSI('Creation');
            MainForm.MainList.Items.Item[1].Caption := rSI('Editing');
            MainForm.MainList.Items.Item[2].Caption := rSI('Settings');
            MainForm.MainList.Items.Item[3].Caption := rSI('About');
            MainForm.CreationList.Items.Strings[0] := rSI('CreationList_Part1');
            MainForm.CreationList.Items.Strings[1] := rSI('CreationList_Part2');
            MainForm.EditionList.Items.Strings[0] := rSI('EditionList_Part1');
            MainForm.EditionList.Items.Strings[1] := rSI('EditionList_Part2');
            MainForm.EditionList.Items.Strings[2] := rSI('EditionList_Part3');
            MainForm.EditionList.Items.Strings[3] := rSI('EditionList_Part4');
            MainForm.EditionList.Items.Strings[4] := rSI('EditionList_Part5');
            MainForm.SettingsList.Items.Strings[0] := rSI('SettingsList_Part1');
            Yclosed := rSI('Yclosed'); Floaded := rSI('Floaded');
            Msg1 := rSI('Msg1'); Msg2 := rSI('Msg2'); Msg3 := rSI('Msg3');
            Msg4 := rSI('Msg4'); Msg41 := rSI('Msg41'); Msg5 := rSI('Msg5');
            Msg6 := rSI('Msg6'); Msg7 := rSI('Msg7'); Msg8 := rSI('Msg8');
            Msg9 := rSI('Msg9'); Msg10 := rSI('Msg10'); Msg11 := rSI('Msg11');
            Msg12 := rSI('Msg12'); Msg13 := rSI('Msg13');
            MsgOverwritten := rSI('MsgOverwritten');
            MsgOverwriteOrNot := rSI('MsgOverwriteOrNot');
            MsgNotCompatible1 := rSI('MsgNotCompatible1');
            MsgNotCompatible2 := rSI('MsgNotCompatible2');
            MsgStarted := rSI('MsgStarted');
            MsgOSType := rSI('MSgOSType');
            MsgMP4BoxFound := rSI('MsgMP4BoxFound');
            MsgMP4BoxMissing := rSI('MsgMP4BoxMissing');
            MsgTaggerMissing := rSI('MsgTaggerMissing');
            BadTagger := rSI('BadTagger');
            BadMP4Box := rSI('BadMP4Box');
            Msgx264VFWCompatiblity := rSI('Msgx264VFWCompatiblity');
            MsgNotifying := rSI('MsgNotifying');
            btYes := rSI('btYes'); btNo := rSI('btNo');
            ProcessIsRunningMsg := rSI('ProcessIsRunningMsg');
            MsgTaggerFound := rSI('MsgTaggerFound');
            MsgTaggerFoundButNotSupported := rSI('MsgTaggerFoundButNotSupported');
            rawAVCMsg := rSI('rawAVCMsg');
            OverwriteMsgExp := rSI('OverwriteMsgExp');
            ClickToHideMsg := rSI('ClickToHideMsg');
            ClickToSeeMoreMsg := rSI('ClickToSeeMoreMsg');

            //Settings Page
            MainForm.WHeaderSettingsPage.Captions.Text := rSI2('TitleText');
            MainForm.WHeaderSettingsPage.Comments.Text := rSI2('SubtitleText');
            MainForm.chOverWrite.Caption := rSI2('OverwriteChBox');
            MainForm.chKeepSys.Caption := rSI2('KeepAllMPEG4');
            MainForm.chFlat.Caption := rSI2('FlatForStreaming');
            MainForm.lbProcess.Caption := rSI2('ProcessPriority');
            MainForm.lbLang.Caption := rSI2('Language');
            MainForm.chEnableOnFinish.Caption := rSI2('OnFinishEvent');
            MainForm.chYambLog.Caption := rSI2('LogYambFolder');
            MainForm.chOutputLog.Caption := rSI2('LogOutputFolder');
            MainForm.chiTunesStyle.Caption := rSI2('iTunesStyle');
            MainForm.chVerbose.Caption := rSI2('VerboseMode');
            MainForm.chWarningAVC.Caption := rSI2('Warning4AVC');

            //About Page
            MainForm.lbLinks.Caption := rSI3('Links');
            MainForm.lbMP4Box.Caption := rSI3('MP4Box');
            MainForm.lbAP.Caption := rSI3('AP');
            MainForm.lbMP4Tags.Caption := rSI3('MP4Tags');
            MainForm.lbYamb.Caption := rSI3('Yamb');
            MainForm.lbThanks.Caption := rSI3('ThanksTo');
            MainForm.lbMediaInfo.Caption := rSI3('MediaInfo');
            MainForm.lbJVCL.Caption := rSI3('JVCL');
            MainForm.lbKDE.Caption := rSI3('KDE');
            MainForm.lbYou.Caption := rSI3('You');

            //MuxPage
            MP4FileCreation := rSI4('TitleText');
            GPPFileCreation := rSI4('TitleText2');
            MainForm.WHeaderMuxPage.Comments.Text := rSI4('SubtitleText');
          //  MainForm.MuxPage.Subtitle.Text := rSI4('SubtitleText');
            MainForm.MP4ListView.Columns[1].Caption := rSI4('Path');
            MainForm.MP4ListView.Columns[2].Caption := rSI4('File');
            MainForm.MP4ListView.Columns[3].Caption := rSI4('Index');
            MainForm.MP4ListView.Columns[4].Caption := rSI4('Description');
            MainForm.MP4ListView.Columns[5].Caption := rSI4('Name');
            MainForm.MP4ListView.Columns[6].Caption := rSI4('Language');
            MainForm.btAdd.Caption := rSI4('btAdd');
            MainForm.btDelete.Caption := rSI4('btDelete');
            MainForm.btMoveUp.Caption := rSI4('btMoveUp');
            MainForm.btMoveDown.Caption := rSI4('btMoveDown');
            MainForm.btProperties.Caption := rSI4('btProperties');
            MainForm.chVFR.Caption := rSI4('VFRCreate');
            MainForm.lbSplitat.Caption := rSI4('lbSplitAt');
            MainForm.btMP4Output.Caption := rSI4('btBrowse');
            MainForm.lbCompliance.Caption := rSI4('Compliance');
         //   MainForm.chiPod.Caption := rSI4('iPodCompliant');
            MainForm.chHint.Caption := rSI4('Hint');
            MuxTitleText := rSI4('TitleText');

            //ProcessPage
          //  MainForm.ProcessPage.Title.Text := rSI5('TitleText');
            MainForm.WHeaderProcessPage.Captions.Text := rSI5('TitleText');
            MainForm.WHeaderProcessPage.Comments.Text := rSI5('SubtitleText');
         //   MainForm.ProcessPage.Subtitle.Text := rSI5('SubtitleText');
            MainForm.ETAListView.Columns[1].Caption := rSI5('Time');
            MainForm.ETAListView.Columns[2].Caption := rSI5('Events');
            MainForm.lbCurrentStatus.Caption := rSI5('CurrentStatus');
            MainForm.lbTime.Caption := rSI5('TimeRemain');
            MainForm.btAbort.Caption := rSI5('btAbort');
            ConvAborted := rSI5('ConvAborted');
            ConvFailed := rSI5('ConvFailded');
            ConvSucceed := rSI5('ConvSucceed');
            ExtractAborted := rSI5('ExtractAborted');
            ExtractFailed := rSI5('ExtractFailded');
            ExtractSucceed := rSI5('ExtractSucceed');
            ConcatAborted := rSI5('ConcatAborted');
            ConcatFailed := rSI5('ConcatFailed');
            ConcatSucceed := rSI5('ConcatSucceed');
            CreateAborted := rSI5('CreateAborted');
            CreateFailed := rSI5('CreateFailed');
            CreateSucceed := rSI5('CreateSucceed');
            SplitAborted := rSI5('SplitAborted');
            SplitFailed := rSI5('SplitFailed');
            SplitSucceed := rSI5('SplitSucceed');
            TagAborted := rSI5('TagAborted');
            TagFailed := rSI5('TagFailed');
            TagSucceed := rSI5('TagSucceed');
            ImportAVIVideo := rSI5('ImportAVIVideo');
            ImportAVIAudio := rSI5('ImportAVIAudio');
            ImportVobsubFile := rSI5('ImportVobsubFile');
            ImportISOFile := rSI5('ImportISOFile');
            ImportSRTFile := rSI5('ImportSRTFile');
            ImportTTXTFile := rSI5('ImportTTXTFile');
            ImportAACFile := rSI5('ImportAACFile');
            ImportImageFile := rSI5('ImportImageFile');
            StoringFile := rSI5('StoringFile');
            ImportM4VFile := rSI5('ImportM4VFile');
            ImportPSVideoFile := rSI5('ImportPSVideoFile');
            ImportPSAudioFile := rSI5('ImportPSAudioFile');
            ImportTSFile := rSI5('ImportTSFile');
            ImportMP3File := rSI5('ImportMP3File');
            ImportAVCFile := rSI5('ImportAVCFile');
            ImportNHNTFile := rSI5('ImportNHNTFile');
            ImportNHMLFile := rSI5('ImportNHMLFile');
            ImportAMRFile := rSI5('ImportAMRFile');
            ImportEVRCFile := rSI5('ImportEVRCFile');
            ImportSMVFile := rSI5('ImportSMVFile');
            ImportQCPFile := rSI5('ImportQCPFile');
            ImportAMRWBFile := rSI5('ImportAMRWBFile');
            ImportOGGVideo := rSI5('ImportOGGVideo');
            ImportOGGAudio := rSI5('ImportOGGAudio');
            ImportSAFFile := rSI5('ImportSAFFile');
            ImportH263File := rSI5('ImportH263File');
            ImportTeXMLFile := rSI5('ImportTeXMLFile');
            FileW := rSI5('FileW');
            FileI := rSI5('FileI');
            FileS := rSI5('FileS');
            FileA := rSI5('FileA');
            FileTag := rSI5('FileTag');
            UnknownPID := rSI5('UnknownPID');
            InvalidUTF := rSI5('InvalidUTF');
            MsgError := rSI5('MsgError');
            AVCinAVIDetect := rSI5('AVCinAVIDetect');
            CmdUsedForExtract := rSI5('CmdUsedForExtract');
            FinishCaption := rSI5('FinishCaption');
            MsgNewTask := rSI5('MsgNewTask');
            ClickToHide := rSI5('ClickToHide');
            ClickToSeeMore := rSI5('ClickToSeeMore');

            // SplitPage
            MainForm.WizardHeaderSplitPage.Captions.Text := rSI6('TitleText');
            MainForm.WizardHeaderSplitPage.Comments.Text := rSI6('SubtitleText');
            MainForm.chVIdeoPreview.Caption := rSI6('VideoPreview');
            MainForm.rbSize.Caption := rSI6('SplitbySize');
            MainForm.rbDuration.Caption := rSI6('SplitbyDuration');
            MainForm.rbFrom.Caption := rSI6('SplitFrom');
            MainForm.lbTo.Caption := rSI6('SplitTo');
            MainForm.rbSplitChapN.Caption := rSI6('SplitbyChapters');
            MainForm.rbSplitChapAll.Caption := rSI6('SplitbyAllChapters');
            Split10 := rSI6('Split10');
            Split11 := rSI6('Split11');
            Split12 := rSI6('Split12');
            Split13 := rSI6('Split13');
            Split14 := rSI6('Split14');
            Split15 := rSI6('Split15');
            Split20 := rSI6('Split20');
            Split21 := rSI6('Split21');
            Split22 := rSI6('Split22');
            Split23 := rSI6('Split23');
            Split24 := rSI6('Split24');
            Split30 := rSI6('Split30');
            Split31 := rSI6('Split31');
            Split32 := rSI6('Split32');
            Split33 := rSI6('Split33');
            Split34 := rSI6('Split34');
            Split40 := rSI6('Split40');
            Split41 := rSI6('Split41');
            Split50 := rSI6('Split50');
            Split51 := rSI6('Split51');

            // ExtractPage
            MainForm.WHeaderExtractPage.Captions.Text := rSI7('TitleText');
            MainForm.WHeaderExtractPage.Comments.Text := rSI7('SubtitleText');
            MainForm.gbContent.Caption := rSI7('gbContent');
            MainForm.ExtractListView.Columns[2].Caption := rSI4('File');
            MainForm.ExtractListView.Columns[4].Caption := rSI4('Description');
            ExtractToAVI := rSI7('ExtractToAVI');
            ExtractToRAW := rSI7('ExtractToRAW');
            ExtractToMP4 := rSI7('ExtractToMP4');
            ExtractToRawAll := rSI7('ExtractToRawAll');
            ExtractVideoStream := rSI7('ExtractVideoStream');
            ExtractAudioStream := rSI7('ExtractAudioStream');
            ExtractToSRT := rSI7('ExtractToSRT');
            ExtractToTTXT := rSI7('ExtractToTTXT');
            ExtractToOGM := rSI7('ExtractToOGM');
            ExtractToCUE := rSI7('ExtractToCUE');
            msgExtractRawVideo := rSI7('MsgExtractRawVideo');
            MsgExtractRawAudio := rSI7('MsgExtractRawAudio');
            MsgExtractVobSub := rSI7('MsgExtractVobSub');
            MsgExtractSubtitle := rSI7('MsgExtractSubtitle');
            MsgToSRTFormat := rSI7('MsgToSRTFormat');
            MsgToTTXTFormat := rSI7('MsgToTTXTFormat');
            MsgExtractChapters := rSI7('MsgExtractChapters');
            MsgToOGMTextFormat := rSI7('MsgToOGMTextFormat');
            MsgToCueSheetFormat := rSI7('MsgToCueSheetFormat');
            MsgEncapsulateVideoInMP4 := rSI7('MsgEncapsulateVideoInMP4');
            MsgEncapsulateVideoInAVI := rSI7('MsgEncapsulateVideoInAVI');
            MsgCmdUsedForExtraction := rSI7('MsgCmdUsedForExtraction');
            MsgFileSavedIn := rSI7('MsgFilesSavedIn');


            // Properties
            PropForm.PageControl.Pages[0].Caption := rSI8('TrackProp');
            PropForm.PageControl.Pages[1].Caption := rSI8('TaggerProp');
            PropForm.PageControl.Pages[2].Caption := rSI8('TabMore');
            PropForm.PageControl.Pages[3].Caption := rSI8('TabPic');
            PropForm.gbSource.Caption := rSI8('gbSourceInfo');
            PropForm.gbProperties.Caption := rSI8('gbProperties');
            PropForm.chTagSupport.Caption := rSI8('chTagSupport');
            PropForm.btCancel.Caption := rSI('Cancel');
            PropForm.spbt1.Hint := rSI8('PreviousTrackSelected');
            PropForm.dpbt2.Hint := rSI8('NextTrackSelected');
            lbType := rSI8('lbType');
            lbVideoStream := rSI8('lbVideoStream');
            lbAudioStream := rSI8('lbAudioStream');
            lbSubStream := rSI8('lbSubStream');
            lbInfo := rSI8('lbInfo');
            lbFile := rSI8('lbFile');
            PropForm.Caption := rSI8('PropForm');

            // ConcatPage
            MainForm.WizardHeaderConcatPage.Captions.Text := rSI9('TitleText');
            MainForm.WizardHeaderConcatPage.Comments.Text := rSI9('SubtitleText');
            MainForm.ConcListView.Columns[1].Caption := rSI4('Path');
            MainForm.ConcListView.Columns[2].Caption := rSI4('File');
            MainForm.ConcListView.Columns[3].Caption := rSI4('Index');
            MainForm.ConcListView.Columns[4].Caption := rSI4('Description');
            MainForm.ConcListView.Columns[5].Caption := rSI4('Name');
            MainForm.ConcListView.Columns[6].Caption := rSI4('Language');
            MainForm.btConcAdd.Caption := rSI4('btAdd');
            MainForm.btConcRemove.Caption := rSI4('btDelete');
            MainForm.btConcMoveUp.Caption := rSI4('btMoveUp');
            MainForm.btConcMoveDown.Caption := rSI4('btMoveDown');
            MainForm.btConcProp.Caption := rSI4('btProperties');
            MainForm.btConcBrowse.Caption := rSI4('btBrowse');
            MainForm.lbCompliance2.Caption := rSI4('Compliance');

            // One-Click Converter
            MainForm.WHeaderOneClickConv.Captions.Text := rSI10('TitleText');
            MainForm.WHeaderOneClickConv.Comments.Text := rSI10('SubtitleText');
            MainForm.gbSub.Caption := rSI10('SubOptions');
            MainForm.rbSRT.Caption := rSI10('ConvSRT');
            MainForm.rbTTXT.Caption := rSI10('ConvTTXT');
            MainForm.gbAVIOptions.Caption := rSI10('VideoOptions');
            MainForm.AVIConverterText.Caption := rSI10('NoteForVideo');

        finally
        free;
     end;
end;

function GetWindowsLanguage(LCTYPE: LCTYPE {type of information}): string;
var
  Buffer : PChar;
  Size : integer;
begin
  Size := GetLocaleInfo (LOCALE_USER_DEFAULT, LCType, nil, 0);
  GetMem(Buffer, Size);
  try
    GetLocaleInfo (LOCALE_USER_DEFAULT, LCTYPE, Buffer, Size);
    Result := string(Buffer);
  finally
    FreeMem(Buffer);
  end;
end;

procedure SaveListviewStrings(listview: TTnTListView; const filename: WideString);
var
  sl: TStringlist;
  S: string;
  i, k: Integer;
  item: TLIstItem;
begin
  Assert(Assigned(listview));
  if listview.ViewStyle <> vsReport then
    raise Exception.CreateFmt(eInvalidViewstyle, ['SaveListviewStrings',listview.name]);
  sl := TStringlist.Create;
  try
    for i := 0 to listview.items.count - 1 do
    begin
      item := listview.Items[i];
      S := item.Caption;
      for k := 0 to item.SubItems.Count - 1 do
        S := S + {#9}' | ' + item.Subitems[k];
      sl.Add(S);
    end;
    sl.SaveToFile(filename);
  finally
    sl.free
  end;
end;

procedure OverwriteMsg(TaskDiag : TTntTaskDialog; OutputFile : WideString);
begin
     TaskDiag.Title := 'Overwriting';
     TaskDiag.Icon := tiQuestion;
     TaskDiag.CustomButtons.Clear;
     TaskDiag.CustomButtons.Add(btYes);
     TaskDiag.CustomButtons.Add(btNo);
     TaskDiag.DefaultButton := 100;
     TaskDiag.Instruction := Format(MsgOverwriteOrNot+' %s ?',[WideExtractFileName(OutputFile)]);
     TaskDiag.ExpandedText := OverwriteMsgExp;
     TaskDiag.ExpandControlText := ClickToHideMsg;
     TaskDiag.CollapsControlText := ClickToSeeMoreMsg;
end;

procedure MP4BoxMissingMsg(TaskDiag : TTntTaskDialog);
begin
     TaskDiag.Title := 'Information';
     TaskDiag.Icon := tiInformation;
     TaskDiag.CustomButtons.Clear;
     TaskDiag.CustomButtons.Add('&Ok');
     TaskDiag.DefaultButton := 100;
     TaskDiag.Instruction := Msg41;
     TaskDiag.Content := Msg4;
end;

procedure DeleteItemMsg(TaskDiag : TTntTaskDialog);
begin
     TaskDiag.Title := 'Delete';
     TaskDiag.Icon := tiWarning;
     TaskDiag.CustomButtons.Clear;
     TaskDiag.CustomButtons.Add(btYes);
     TaskDiag.CustomButtons.Add(btNo);
     TaskDiag.DefaultButton := 100;
     TaskDiag.Instruction := Msg1;
end;

procedure MsgNotCompatible(TaskDiag: TTntTaskDialog; Num: Integer);
begin
     TaskDiag.Title := 'Information';
     TaskDiag.Icon := tiInformation;
     TaskDiag.CustomButtons.Clear;
     TaskDiag.CustomButtons.Add('&Ok');
     TaskDiag.DefaultButton := 100;
     TaskDiag.Instruction := MsgNotifying;
     if Num = 0 then TaskDiag.Content := Msgx264VFWCompatiblity
     else if Num = 1 then TaskDiag.Content := MsgNotCompatible1
     else TaskDiag.Content := MsgNotCompatible2;
     TaskDiag.Execute;
end;

procedure MsgProcessRunning(TaskDiag: TTntTaskDialog);
begin
     TaskDiag.Title := 'Information';
     TaskDiag.Icon := tiInformation;
     TaskDiag.CustomButtons.Clear;
     TaskDiag.CustomButtons.Add('&Ok');
     TaskDiag.DefaultButton := 100;
     TaskDiag.Instruction := ProcessIsRunningMsg;
     TaskDiag.Execute;
end;

procedure MsgrawAVC(TaskDiag: TTntTaskDialog);
begin
     TaskDiag.Title := 'Information';
     TaskDiag.Icon := tiInformation;
     TaskDiag.CustomButtons.Clear;
     TaskDiag.CustomButtons.Add('&Ok');
     TaskDiag.DefaultButton := 100;
     TaskDiag.Instruction := MsgNotifying;
     TaskDiag.Content := rawAVCMsg;
end;

procedure GetAllFiles(mask: string);
var
  search: TSearchRec;
  directory: string;
  FileList : TListItem;

begin
  directory := ExtractFilePath(mask);
  FileList := MainForm.FilesTagList.Items.Add;
  
  // find all files
  if FindFirst(mask, $23, search) = 0 then
  begin
     
    repeat
      // add the files to the listbox
     // Form1.ListBox1.Items.Add(directory + search.Name);
      begin

      FileList.SubItems.Add(directory);
      FileList.SubItems.Add(Search.Name);
      Inc(Count);
      end;
    until FindNext(search) <> 0;
  end;

  // Subdirectories/ Unterverzeichnisse
  if FindFirst(directory + '*.*', faDirectory, search) = 0 then
  begin
    repeat
      if ((search.Attr and faDirectory) = faDirectory) and (search.Name[1] <> '.') then
        GetAllFiles(directory + search.Name + '\' + ExtractFileName(mask));
    until FindNext(search) <> 0;
    FindClose(search);
  end;
end;

procedure EraseTagsEdit;
begin
     if PropForm.edName.Text <> '' then PropForm.edName.Text := '';
     if PropForm.edArtist.Text <> '' then PropForm.edArtist.Text := '';
     if PropForm.edYear.Text <> '' then PropForm.edYear.Text := '';
     if PropForm.edWriter.Text <> '' then PropForm.edWriter.Text := '';
     if PropForm.edTrackN1.Text <> '' then PropForm.edTrackN1.Text := '';
     if PropForm.edTrackNum2.Text <> '' then PropForm.edTrackNum2.Text := '';
     if PropForm.edAlbum.Text <> '' then PropForm.edAlbum.Text := '';
     if PropForm.edDiskNum1.Text <> '' then PropForm.edDiskNum1.Text := '';
     if PropForm.edDiskNum2.Text <> '' then PropForm.edDiskNum2.Text := '';
     if PropForm.edGroup.Text <> '' then PropForm.edGroup.Text := '';
     if PropForm.edTempo.Text <> '' then PropForm.edTempo.Text := '';
     if PropForm.edComposer.Text <> '' then PropForm.edComposer.Text := '';
     if PropForm.edEncoder.Text <> '' then PropForm.edEncoder.Text := '';
     if PropForm.edTool.Text <> '' then PropForm.edTool.Text := '';
     if PropForm.cbGenre.ItemIndex <> 19 then PropForm.cbGenre.ItemIndex := 19;
     if PropForm.chCompile.Checked then PropForm.chCompile.Checked := False;
     if PropForm.chGapless.Checked then PropForm.chGapless.Checked := False;
     if PropForm.MemoComments.Text <> '' then PropForm.MemoComments.Text := '';
     PropForm.ThumbView.EmptyList;
     if PropForm.chTagSupport.Checked then PropForm.chTagSupport.Checked := False;
end;

function SetNameTags(prefix: Integer): WideString;
var ed: WideString;
begin
     if prefix=1 then ed := PropForm.edName.Text else ed := MainForm.edName.Text;
     if ed <> '' then Result := '"name='+EncodeUTF8(ed) else Result := '';
end;

function SetArtistTags(prefix: Integer): WideString;
var ed: WideString;
begin
     if prefix=1 then ed := PropForm.edArtist.Text else ed := MainForm.edArtist.Text;
     if ed <> '' then
       begin
            if prefix=1 then // PropForm
              begin
                   if (PropForm.edName.Text <> '') or
                      (PropForm.edYear.Text <> '') or
                      (PropForm.edWriter.Text <> '') or
                      (PropForm.edTrackN1.Text <> '') or
                      (PropForm.edTrackNum2.Text <> '') or
                      (PropForm.edAlbum.Text <> '') or
                      (PropForm.edDiskNum1.Text <> '') or
                      (PropForm.edDiskNum2.Text <> '') or
                      (PropForm.edGroup.Text <> '') or
                      (PropForm.edTempo.Text <> '') or
                      (PropForm.edComposer.Text <> '') or
                      (PropForm.chCompile.Checked) or
                      (PropForm.chGapless.Checked) or
                      (PropForm.MemoComments.Text <> '') or
                      (PropForm.ThumbView.SelectedFile <> '') or
                      (PropForm.cbGenre.Text <> '') or
                      (PropForm.edEncoder.Text <> '') or
                      (PropForm.edTool.Text <> '') then
                        Result := ':artist='+EncodeUTF8(ed)
                   else Result := 'artist="'+EncodeUTF8(ed);
              end
            else // MainForm
              begin
                   if (MainForm.edName.Text <> '') or
                      (MainForm.edAlbum.Text <> '') or
                      (MainForm.edYear.Text <> '') or
                      (MainForm.cbGenre.Text <> '') or
                      (MainForm.edPic.Text <> '') then
                        Result := ':artist='+EncodeUTF8(ed)
                   else Result := 'artist="'+EncodeUTF8(ed);
              end;
       end
     else Result := '';
end;

function SetAlbumTags(prefix: Integer): WideString;
var ed: WideString;
begin
     if prefix=1 then ed := PropForm.edAlbum.Text else ed := MainForm.edAlbum.Text;
     if ed <> '' then
       begin
            if prefix=1 then // PropForm
              begin
                   if (PropForm.edName.Text <> '') or
                      (PropForm.edYear.Text <> '') or
                      (PropForm.edArtist.Text <> '') or
                      (PropForm.edWriter.Text <> '') or
                      (PropForm.edTrackN1.Text <> '') or
                      (PropForm.edTrackNum2.Text <> '') or
                      (PropForm.edDiskNum1.Text <> '') or
                      (PropForm.edDiskNum2.Text <> '') or
                      (PropForm.edGroup.Text <> '') or
                      (PropForm.edTempo.Text <> '') or
                      (PropForm.edComposer.Text <> '') or
                      (PropForm.chCompile.Checked) or
                      (PropForm.chGapless.Checked) or
                      (PropForm.MemoComments.Text <> '') or
                      (PropForm.ThumbView.SelectedFile <> '') or
                      (PropForm.cbGenre.Text <> '') or
                      (PropForm.edEncoder.Text <> '') or
                      (PropForm.edTool.Text <> '') then
                        Result := ':album='+EncodeUTF8(ed)
                   else Result := 'album="'+EncodeUTF8(ed);
              end
            else  // MainForm
              begin
                   if (MainForm.edName.Text <> '') or
                      (MainForm.edArtist.Text <> '') or
                      (MainForm.edYear.Text <> '') or
                      (MainForm.cbGenre.Text <> '') or
                      (MainForm.edPic.Text <> '') then
                        Result := ':album='+EncodeUTF8(ed)
                   else Result := 'album="'+EncodeUTF8(ed);
              end;
       end
     else Result := '';
end;

function SetYearTags(prefix: Integer): WideString;
var ed: WideString;
begin
     if prefix=1 then ed := PropForm.edYear.Text else ed := MainForm.edYear.Text;
     if ed <> '' then
       begin
            if prefix=1 then // PropForm
              begin
                   if (PropForm.edName.Text <> '') or
                      (PropForm.edArtist.Text <> '') or
                      (PropForm.edWriter.Text <> '') or
                      (PropForm.edTrackN1.Text <> '') or
                      (PropForm.edTrackNum2.Text <> '') or
                      (PropForm.edAlbum.Text <> '') or
                      (PropForm.edDiskNum1.Text <> '') or
                      (PropForm.edDiskNum2.Text <> '') or
                      (PropForm.edGroup.Text <> '') or
                      (PropForm.edTempo.Text <> '') or
                      (PropForm.edComposer.Text <> '') or
                      (PropForm.chCompile.Checked) or
                      (PropForm.chGapless.Checked) or
                      (PropForm.MemoComments.Text <> '') or
                      (PropForm.ThumbView.SelectedFile <> '') or
                      (PropForm.cbGenre.Text <> '') or
                      (PropForm.edEncoder.Text <> '') or
                      (PropForm.edTool.Text <> '') then
                        Result := ':created='+ed
                   else Result := 'created="'+ed;
              end
            else // MainForm
              begin
                   if (MainForm.edName.Text <> '') or
                      (MainForm.edArtist.Text <> '') or
                      (MainForm.edAlbum.Text <> '') or
                      (MainForm.cbGenre.Text <> '') or
                      (MainForm.edPic.Text <> '') then
                        Result := ':created='+ed
                   else Result := 'created="'+ed;
              end;
       end
     else Result := '';              
end;

function SetPictureTags(prefix: Integer): WideString;
var ed: WideString;
begin
     if prefix=1 then ed := PropForm.ThumbView.SelectedFile else ed := MainForm.edPic.Text;
     if ed <> '' then
       begin
            if prefix=1 then // PropForm
              begin
                   if PropForm.ThumbView.Count > 0 then
                     begin
                          if (PropForm.edName.Text <> '') or
                             (PropForm.edYear.Text <> '') or
                             (PropForm.edArtist.Text <> '') or
                             (PropForm.edWriter.Text <> '') or
                             (PropForm.edTrackN1.Text <> '') or
                             (PropForm.edTrackNum2.Text <> '') or
                             (PropForm.edAlbum.Text <> '') or
                             (PropForm.edDiskNum1.Text <> '') or
                             (PropForm.edDiskNum2.Text <> '') or
                             (PropForm.edGroup.Text <> '') or
                             (PropForm.edTempo.Text <> '') or
                             (PropForm.edComposer.Text <> '') or
                             (PropForm.chCompile.Checked) or
                             (PropForm.chGapless.Checked) or
                             (PropForm.MemoComments.Text <> '') or
                             (PropForm.cbGenre.Text <> '') or
                             (PropForm.edEncoder.Text <> '') or
                             (PropForm.edTool.Text <> '') then
                               Result := ':cover='+PropForm.ThumbView.SelectedFile
                          else Result := 'cover="'+PropForm.ThumbView.SelectedFile;
                     end;
              end
            else // MainForm
              begin
                   if (MainForm.edName.Text <> '') or
                      (MainForm.edArtist.Text <> '') or
                      (MainForm.edAlbum.Text <> '') or
                      (MainForm.cbGenre.Text <> '') or
                      (MainForm.edYear.Text <> '') then
                        Result := ':cover='+MainForm.edPic.Text
                   else Result := 'cover="'+MainForm.edPic.Text;
              end;
       end
     else Result := '';
end;

function SetGenreTags(prefix: Integer): WideString;
var ed: WideString;
begin
     if prefix=1 then ed := PropForm.cbGenre.Text else ed := MainForm.cbGenre.Text;
     if ed <> '' then
       begin
            if prefix=1 then
              begin
                   if (PropForm.edName.Text <> '') or
                      (PropForm.edYear.Text <> '') or
                      (PropForm.edArtist.Text <> '') or
                      (PropForm.edWriter.Text <> '') or
                      (PropForm.edTrackN1.Text <> '') or
                      (PropForm.edTrackNum2.Text <> '') or
                      (PropForm.edAlbum.Text <> '') or
                      (PropForm.edDiskNum1.Text <> '') or
                      (PropForm.edDiskNum2.Text <> '') or
                      (PropForm.edGroup.Text <> '') or
                      (PropForm.edTempo.Text <> '') or
                      (PropForm.edComposer.Text <> '') or
                      (PropForm.chCompile.Checked) or
                      (PropForm.MemoComments.Text <> '') or
                      (PropForm.ThumbView.SelectedFile <> '') or
                      (PropForm.edEncoder.Text <> '') or
                      (PropForm.edTool.Text <> '') then
                        Result := ':genre='+PropForm.cbGenre.Text
                   else Result := cmd+'genre="'+PropForm.cbGenre.Text;
              end
            else // MainForm
              begin
                   if (MainForm.edName.Text <> '') or
                      (MainForm.edArtist.Text <> '') or
                      (MainForm.edAlbum.Text <> '') or
                      (MainForm.edPic.Text <> '') or
                      (MainForm.edYear.Text <> '') then
                        Result := ':genre='+MainForm.cbGenre.Text
                   else Result := cmd+'genre="'+MainForm.cbGenre.Text;
              end;
       end
     else Result := '';
end;

function SetWriterTags(prefix: Integer): WideString;
begin
     if prefix=1 then
       begin
            if (PropForm.edName.Text <> '') or
                      (PropForm.edYear.Text <> '') or
                      (PropForm.edArtist.Text <> '') or
                      (PropForm.edTrackN1.Text <> '') or
                      (PropForm.edTrackNum2.Text <> '') or
                      (PropForm.edAlbum.Text <> '') or
                      (PropForm.edDiskNum1.Text <> '') or
                      (PropForm.edDiskNum2.Text <> '') or
                      (PropForm.edGroup.Text <> '') or
                      (PropForm.edTempo.Text <> '') or
                      (PropForm.edComposer.Text <> '') or
                      (PropForm.chCompile.Checked) or
                      (PropForm.chGapless.Checked) or
                      (PropForm.MemoComments.Text <> '') or
                      (PropForm.ThumbView.SelectedFile <> '') or
                      (PropForm.cbGenre.Text <> '') or
                      (PropForm.edEncoder.Text <> '') or
                      (PropForm.edTool.Text <> '') then
                 Result := ':writer='+EncodeUTF8(PropForm.edWriter.Text)
            else Result := cmd+'writer="'+EncodeUTF8(PropForm.edWriter.Text);
       end;
end;

function SetDiskPTags(prefix: Integer): WideString;
begin
     if prefix=1 then
       begin
            if (PropForm.edName.Text <> '') or
               (PropForm.edYear.Text <> '') or
               (PropForm.edArtist.Text <> '') or
               (PropForm.edWriter.Text <> '') or
               (PropForm.edTrackN1.Text <> '') or
               (PropForm.edTrackNum2.Text <> '') or
               (PropForm.edAlbum.Text <> '') or
               (PropForm.edGroup.Text <> '') or
               (PropForm.edTempo.Text <> '') or
               (PropForm.edComposer.Text <> '') or
               (PropForm.chCompile.Checked) or
               (PropForm.chGapless.Checked)  or
               (PropForm.MemoComments.Text <> '') or
               (PropForm.ThumbView.SelectedFile <> '') or
               (PropForm.cbGenre.Text <> '') or
               (PropForm.edEncoder.Text <> '') or
               (PropForm.edTool.Text <> '') then
                  Result := ':disk='+PropForm.edDiskNum1.Text+'/'+PropForm.edDiskNum2.Text
             else Result := 'disk="'+PropForm.edDiskNum1.Text+'/'+PropForm.edDiskNum2.Text;
       end;
end;

function SetDiskTTags(prefix: Integer): WideString;
begin
     if prefix=1 then
       begin
            if (PropForm.edName.Text <> '') or
               (PropForm.edYear.Text <> '') or
               (PropForm.edArtist.Text <> '') or
               (PropForm.edWriter.Text <> '') or
               (PropForm.edTrackN1.Text <> '') or
               (PropForm.edTrackNum2.Text <> '') or
               (PropForm.edAlbum.Text <> '') or
               (PropForm.edGroup.Text <> '') or
               (PropForm.edTempo.Text <> '') or
               (PropForm.edComposer.Text <> '') or
               (PropForm.chCompile.Checked) or
               (PropForm.chGapless.Checked)  or
               (PropForm.MemoComments.Text <> '') or
               (PropForm.ThumbView.SelectedFile <> '') or
               (PropForm.cbGenre.Text <> '') or
               (PropForm.edEncoder.Text <> '') or
               (PropForm.edTool.Text <> '') then
                  Result := ':disk='+PropForm.edDiskNum1.Text+'/'+PropForm.edDiskNum2.Text
             else Result := 'disk="'+PropForm.edDiskNum1.Text+'/'+PropForm.edDiskNum2.Text;
       end;
end;

function SetTrackPTags(prefix: Integer): WideString;
begin
     if prefix=1 then
       begin
            if (PropForm.edName.Text <> '') or
               (PropForm.edYear.Text <> '') or
               (PropForm.edArtist.Text <> '') or
               (PropForm.edWriter.Text <> '') or
               (PropForm.edTrackNum2.Text <> '') or
               (PropForm.edAlbum.Text <> '') or
               (PropForm.edDiskNum1.Text <> '') or
               (PropForm.edDiskNum2.Text <> '') or
               (PropForm.edGroup.Text <> '') or
               (PropForm.edTempo.Text <> '') or
               (PropForm.edComposer.Text <> '') or
               (PropForm.chCompile.Checked) or
               (PropForm.chGapless.Checked) or
               (PropForm.MemoComments.Text <> '') or
               (PropForm.ThumbView.SelectedFile <> '') or
               (PropForm.cbGenre.Text <> '') or
               (PropForm.edEncoder.Text <> '') or
               (PropForm.edTool.Text <> '') then
                  Result := ':tracknum='+PropForm.edTrackN1.Text
             else Result := 'tracknum="'+PropForm.edTrackN1.Text;
       end;
end;

function SetTrackTTags(prefix: Integer): WideString;
begin
     if prefix=1 then
       begin
            if (PropForm.edName.Text <> '') or
               (PropForm.edYear.Text <> '') or
               (PropForm.edArtist.Text <> '') or
               (PropForm.edWriter.Text <> '') or
               (PropForm.edTrackN1.Text <> '') or
               (PropForm.edAlbum.Text <> '') or
               (PropForm.edDiskNum1.Text <> '') or
               (PropForm.edDiskNum2.Text <> '') or
               (PropForm.edGroup.Text <> '') or
               (PropForm.edTempo.Text <> '') or
               (PropForm.edComposer.Text <> '') or
               (PropForm.chCompile.Checked) or
               (PropForm.chGapless.Checked) or
               (PropForm.MemoComments.Text <> '') or
               (PropForm.ThumbView.SelectedFile <> '') or
               (PropForm.cbGenre.Text <> '') or
               (PropForm.edEncoder.Text <> '') or
               (PropForm.edTool.Text <> '') then
                 Result := ':track='+PropForm.edTrackNum2.Text
            else Result := 'track="'+PropForm.edTrackNum2.Text;
       end;
end;

function SetTempoTags(prefix: Integer): WideString;
begin
     if prefix=1 then
       begin
            if (PropForm.edName.Text <> '') or
               (PropForm.edYear.Text <> '') or
               (PropForm.edArtist.Text <> '') or
               (PropForm.edWriter.Text <> '') or
               (PropForm.edTrackN1.Text <> '') or
               (PropForm.edTrackNum2.Text <> '') or
               (PropForm.edAlbum.Text <> '') or
               (PropForm.edDiskNum1.Text <> '') or
               (PropForm.edDiskNum2.Text <> '') or
               (PropForm.edGroup.Text <> '') or
               (PropForm.edComposer.Text <> '') or
               (PropForm.chCompile.Checked) or
               (PropForm.chGapless.Checked) or
               (PropForm.MemoComments.Text <> '') or
               (PropForm.ThumbView.SelectedFile <> '') or
               (PropForm.cbGenre.Text <> '') or
               (PropForm.edEncoder.Text <> '') or
               (PropForm.edTool.Text <> '') then
                 Result := ':tempo='+PropForm.edTempo.Text
            else Result := 'tempo="'+PropForm.edTempo.Text;
       end;
end;

function SetComposerTags(prefix: Integer): WideString;
begin
     if prefix=1 then
       begin
            if (PropForm.edName.Text <> '') or
               (PropForm.edYear.Text <> '') or
               (PropForm.edArtist.Text <> '') or
               (PropForm.edWriter.Text <> '') or
               (PropForm.edTrackN1.Text <> '') or
               (PropForm.edTrackNum2.Text <> '') or
               (PropForm.edAlbum.Text <> '') or
               (PropForm.edDiskNum1.Text <> '') or
               (PropForm.edDiskNum2.Text <> '') or
               (PropForm.edGroup.Text <> '') or
               (PropForm.edTempo.Text <> '') or
               (PropForm.chCompile.Checked) or
               (PropForm.chGapless.Checked) or
               (PropForm.MemoComments.Text <> '') or
               (PropForm.ThumbView.SelectedFile <> '') or
               (PropForm.cbGenre.Text <> '') or
               (PropForm.edEncoder.Text <> '') or
               (PropForm.edTool.Text <> '') then
                 Result := ':composer='+EncodeUTF8(PropForm.edComposer.Text)
            else Result := 'composer="'+EncodeUTF8(PropForm.edComposer.Text);
       end;
end;

function SetEncoderTags(prefix: Integer): WideString;
begin
     if prefix=1 then
       begin
            if (PropForm.edName.Text <> '') or
               (PropForm.edYear.Text <> '') or
               (PropForm.edArtist.Text <> '') or
               (PropForm.edWriter.Text <> '') or
               (PropForm.edTrackN1.Text <> '') or
               (PropForm.edTrackNum2.Text <> '') or
               (PropForm.edAlbum.Text <> '') or
               (PropForm.edDiskNum1.Text <> '') or
               (PropForm.edDiskNum2.Text <> '') or
               (PropForm.edGroup.Text <> '') or
               (PropForm.edTempo.Text <> '') or
               (PropForm.edComposer.Text <> '') or
               (PropForm.chCompile.Checked) or
               (PropForm.chGapless.Checked) or
               (PropForm.MemoComments.Text <> '') or
               (PropForm.cbGenre.Text <> '') or
               (PropForm.edTool.Text <> '') then
                 Result := ':encoder='+EncodeUTF8(PropForm.edEncoder.Text)
            else Result := 'encoder="'+EncodeUTF8(PropForm.edEncoder.Text);
       end
end;

function SetGroupTags(prefix: Integer): WideString;
begin
      if prefix=1 then
       begin
            if (PropForm.edName.Text <> '') or
               (PropForm.edYear.Text <> '') or
               (PropForm.edArtist.Text <> '') or
               (PropForm.edWriter.Text <> '') or
               (PropForm.edTrackN1.Text <> '') or
               (PropForm.edTrackNum2.Text <> '') or
               (PropForm.edAlbum.Text <> '') or
               (PropForm.edDiskNum1.Text <> '') or
               (PropForm.edDiskNum2.Text <> '') or
               (PropForm.edTool.Text <> '') or
               (PropForm.edTempo.Text <> '') or
               (PropForm.edComposer.Text <> '') or
               (PropForm.chCompile.Checked) or
               (PropForm.chGapless.Checked) or
               (PropForm.MemoComments.Text <> '') or
               (PropForm.cbGenre.Text <> '') or
               (PropForm.edEncoder.Text <> '') then
                 Result := ':group='+EncodeUTF8(PropForm.edGroup.Text)
            else Result := 'group="'+EncodeUTF8(PropForm.edGroup.Text);
       end;
end;

function SetToolTags(prefix: Integer): WideString;
begin
     if prefix=1 then
       begin
            if (PropForm.edName.Text <> '') or
               (PropForm.edYear.Text <> '') or
               (PropForm.edArtist.Text <> '') or
               (PropForm.edWriter.Text <> '') or
               (PropForm.edTrackN1.Text <> '') or
               (PropForm.edTrackNum2.Text <> '') or
               (PropForm.edAlbum.Text <> '') or
               (PropForm.edDiskNum1.Text <> '') or
               (PropForm.edDiskNum2.Text <> '') or
               (PropForm.edGroup.Text <> '') or
               (PropForm.edTempo.Text <> '') or
               (PropForm.edComposer.Text <> '') or
               (PropForm.chCompile.Checked) or
               (PropForm.chGapless.Checked) or
               (PropForm.MemoComments.Text <> '') or
               (PropForm.cbGenre.Text <> '') or
               (PropForm.edEncoder.Text <> '') then
                 Result := ':tool='+EncodeUTF8(PropForm.edTool.Text)
            else Result := 'tool="'+EncodeUTF8(PropForm.edTool.Text);
       end;
end;

function SetCommentsTags(prefix: Integer): WideString;
begin
     if prefix=1 then
       begin
            if (PropForm.edName.Text <> '') or
               (PropForm.edYear.Text <> '') or
               (PropForm.edArtist.Text <> '') or
               (PropForm.edWriter.Text <> '') or
               (PropForm.edTrackN1.Text <> '') or
               (PropForm.edTrackNum2.Text <> '') or
               (PropForm.edAlbum.Text <> '') or
               (PropForm.edDiskNum1.Text <> '') or
               (PropForm.edDiskNum2.Text <> '') or
               (PropForm.edGroup.Text <> '') or
               (PropForm.edTempo.Text <> '') or
               (PropForm.edComposer.Text <> '') or
               (PropForm.chCompile.Checked) or
               (PropForm.chGapless.Checked) or
               (PropForm.ThumbView.SelectedFile <> '') or
               (PropForm.cbGenre.Text <> '') or
               (PropForm.edEncoder.Text <> '') or
               (PropForm.edTool.Text <> '') then
                 Result := ':comment='+EncodeUTF8(PropForm.MemoComments.Text)
            else Result := 'comment="'+EncodeUTF8(PropForm.MemoComments.Text);
       end;
end;

function SetCompileTags(prefix: Integer): WideString;
begin
     if prefix=1 then
       begin
            if (PropForm.edName.Text <> '') or
               (PropForm.edYear.Text <> '') or
               (PropForm.edArtist.Text <> '') or
               (PropForm.edWriter.Text <> '') or
               (PropForm.edTrackN1.Text <> '') or
               (PropForm.edTrackNum2.Text <> '') or
               (PropForm.edAlbum.Text <> '') or
               (PropForm.edDiskNum1.Text <> '') or
               (PropForm.edDiskNum2.Text <> '') or
               (PropForm.edGroup.Text <> '') or
               (PropForm.edTempo.Text <> '') or
               (PropForm.edComposer.Text <> '') or
               (PropForm.MemoComments.Text <> '') or
               (PropForm.chGapless.Checked) or
               (PropForm.ThumbView.SelectedFile <> '') or
               (PropForm.cbGenre.Text <> '') or
               (PropForm.edEncoder.Text <> '') or
               (PropForm.edTool.Text <> '') then
                 Result := ':compilation=yes'
            else Result := 'compilation=yes"';
       end;
end;

function SetGaplessTags(prefix: Integer): WideString;
begin
     if prefix=1 then
       begin
            if (PropForm.edName.Text <> '') or
               (PropForm.edYear.Text <> '') or
               (PropForm.edArtist.Text <> '') or
               (PropForm.edWriter.Text <> '') or
               (PropForm.edTrackN1.Text <> '') or
               (PropForm.edTrackNum2.Text <> '') or
               (PropForm.edAlbum.Text <> '') or
               (PropForm.edDiskNum1.Text <> '') or
               (PropForm.edDiskNum2.Text <> '') or
               (PropForm.edGroup.Text <> '') or
               (PropForm.edTempo.Text <> '') or
               (PropForm.edComposer.Text <> '') or
               (PropForm.MemoComments.Text <> '') or
               (PropForm.chCompile.Checked) or
               (PropForm.ThumbView.SelectedFile <> '') or
               (PropForm.cbGenre.Text <> '') or
               (PropForm.edEncoder.Text <> '') or
               (PropForm.edTool.Text <> '') then
                 Result := ':gapeless=yes'
            else Result := 'gapeless=yes"';
       end;
end;

end.
